#include  <iostream>
#include  <cstdlib>
#include <vector>;
#include <queue>
#include <map>;
#include <stack>;

using  namespace  std;

map<string, int> conectedNodes;
vector<int> connections[10000];
vector<int> weigths[10000];
int pathsFound[10000];

int main()
{
    int N,M;
    cin>>N>>M;


    for(int i = 0; i < M; i++)
    {
        int u,l,r;
        cin>>u>>l>>r;

        for(int i = r; i>=l; i--)
        {
            int value = i - l + 1;

            connections[i-1].push_back(u-1);
            weigths[i-1].push_back(value);
        }
    }

    stack<pair<int, int>> nodesToCheck;
    nodesToCheck.push(pair<int,int>(0,0));
    pair<int, int> curNode;

    while(nodesToCheck.size() != 0)
    {
        curNode = nodesToCheck.top();
        nodesToCheck.pop();

        cout<<"========================";
        for(int i = 0; i<connections[curNode.first].size();i++)
        {
            int curWeigth = weigths[curNode.first][i] + curNode.second;

            cout<<curNode.first<<" " <<connections[curNode.first][i]<<" "<<curWeigth<<endl;

            if(connections[curNode.first][i] == 0)continue;

            if(pathsFound[connections[curNode.first][i]] == 0)
            {
                pathsFound[connections[curNode.first][i]] = curWeigth;
                nodesToCheck.push(pair<int,int>(connections[curNode.first][i],curWeigth));
                continue;
            }
            if(curWeigth < pathsFound[connections[curNode.first][i]])
            {
                pathsFound[connections[curNode.first][i]] = curWeigth;
                nodesToCheck.push(pair<int,int>(connections[curNode.first][i],curWeigth));
            }
        }
    }

    cout<<0<<" ";
    for(int i = 1; i<N; i++)
    {
        if(pathsFound[i] == 0)
        {
            cout<<-1<<" ";
            continue;
        }
        cout<<pathsFound[i]<<" ";
    }
    return 0;
}
