#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

const int MAXN=1e5+5;

int n;
int par[MAXN];
vector<int> adj[MAXN];
int subtr[MAXN];
set<int> s;
long long ans=0;

pair<int,int> findEnds(int v)
{
    auto it1=s.lower_bound(v);
    it1--;
    auto it2=s.upper_bound(v);
    return {(*it1)+1, (*it2)-1};
}

void dfs(int v)
{
    for(auto u: adj[v])
    {
        auto [l,r]=findEnds(u);
        ans+=1*(u-l+1)*(r-u+1)*subtr[u];
        s.insert(u);
        dfs(u);
        s.erase(u);
    }
}

void dfs1(int v)
{
    subtr[v]=1;
    for(auto u: adj[v])
    {
        dfs1(u);
        subtr[v]+=subtr[u];
    }
}

int main()
{
ios::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);

cin>>n;
for(int i=2;i<=n;i++)
{
    cin>>par[i];
    adj[par[i]].push_back(i);
}

dfs1(1);

s.insert(1);
s.insert(n+1);
ans=1L*n*n;
dfs(1);

cout<<ans<<endl;

return 0;
}
