#include <bits/stdc++.h>
#define endl '\n'
using namespace std;
void FastIO()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

const long long INF = 1e18;
const int MAXN = 4000 + 55;
const int MAXM = 2*1e5 + 55;
struct Node
{
    long long to, tg;
    Node () {}
    Node(long long a, long long b)
    {
        to = a;
        tg = b;
    }
};

bool operator <(Node a, Node b)
{
    return a.tg < b.tg;
}
priority_queue<Node> pq;
vector<pair<long long, long long>> g[MAXN];
long long dist[MAXN];
bool used[MAXN];
bool vip[MAXN][MAXN];
int n, m;



void InPut()
{
    cin >> n >> m;
    for(int j = 0; j < m; j ++)
    {
        long long u, l, r;
        cin >> u >> l >> r;
        for(int v = l; v <= r; v ++)
        {
            long long dist = v - l + 1;
            if(vip[u][dist]) continue;
            g[u].push_back({v, dist});
            vip[v][dist];
        }
    }

}

void Dijkstra()
{
    //int startnode = 1;

    pq.push({1, 0});
    for(int i = 1; i <= n; i ++) dist[i] = INF;
    for(auto v: g[1])
    {
        if(v.second < dist[1]) dist[1] = v.second;
    }

    // cout << dist[1] << endl;
    while(!pq.empty())
    {
        Node teki = pq.top();
        pq.pop();
        used[teki.to] = 1;
        for(auto v: g[teki.to])
        {
            if(used[v.first]) continue;

            long long distance = v.second + dist[teki.to];

            //cout << teki.to << " " << v.second << " " << dist[v.first] << endl;
            if(distance < dist[v.first])
            {
                dist[v.first] = distance;
                pq.push({v.first, dist[v.first]});
            }
        }
    }

}

void OutPut()
{
    for(int i = 1; i < n; i ++)
    {
        if(dist[i] == INF) dist[i] = -1;
        cout << dist[i] << " ";
    }
    if(n >= 2)
    {
        if(dist[n] == INF) dist[n] = -1;
        cout << dist[n] << " ";
    }
}
///MAYBE LONG LONG
int main ()
{
    FastIO();
    InPut();
    Dijkstra();
    OutPut();
    return 0;
}
/*
InPut:
10 5
1 1 2
1 8 9
1 7 8
9 3 4
9 3 4

OutPut:
0 2 3 4 -1 -1 1 1 2 -1

*/
