#include <bits/stdc++.h>
#define endl '\n'
using namespace std;
void FastIO()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

const long long INF = 1e18;
const int MAXN = 4000 + 55;
const int MAXM = 200000 + 55;

vector<pair<long long, long long>> g[MAXN];
long long dist[MAXN][MAXN];
bool used[MAXN][MAXN];
int n, m;



void InPut()
{
    cin >> n >> m;
    for(int i = 1; i <= n; i ++)
    {
        for(int j = 1; j <= n; j ++)
        {
            dist[i][j] = INF;
            if(i == j) dist[i][j] = 0;
        }
    }
    for(int j = 0; j < m; j ++)
    {
        long long u, l, r;
        cin >> u >> l >> r;
        for(int v = l; v <= r; v ++)
        {
            long long distance = v - l + 1;
            dist[u][v] = min (dist[u][v], distance);
        }
    }

}

void Floyd()
{
    for(int k = 1; k <= n; k ++)
    {
        for(int i = 1; i <= n; i ++)
        {
            for(int j = 1; j <= n; j ++)
            {
                long long teki = dist[i][k] + dist[k][j];
                dist[i][j] = min(teki, dist[i][j]);
            }
        }
    }
}

void OutPut()
{
    for(int i = 1; i < n; i ++)
    {
        if(dist[1][i] >= INF) dist[1][i] = -1;
        cout << dist[1][i] << " ";
    }
    if(dist[1][n] >= INF) dist[1][n] = -1;
    cout << dist[1][n] << " ";

}
///MAYBE LONG LONG
int main ()
{
    FastIO();
    InPut();
    Floyd();
    OutPut();
    return 0;
}
/*
InPut:
10 5
1 1 2
1 8 9
1 7 8
9 3 4
9 3 4

OutPut:
0 2 3 4 -1 -1 1 1 2 -1

*/
