#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

void FastIO()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

const int MAXN = 500 + 55;
long long par[MAXN];
long long sum[MAXN];
bool used[MAXN], nody[MAXN];
queue<long long> children;
long long n;

void InPut()
{
    cin >> n;
    for(long long i = 2; i <= n; i ++)
    {
        long long tekusht;
        cin >> tekusht;
        used[tekusht] = 1;
        par[i] = tekusht;
    }
}

void bfs()
{
    while(!children.empty())
    {
        long long teki = children.front();
        children.pop();
        long long newparent = par[teki];

        if(sum[teki] == 0)
        {
            sum[teki] = 1;
        }
        if(sum[newparent] == 0)
        {
            sum[newparent] = 1;
            children.push(newparent);
        }
        sum[newparent] += sum[teki];
    }
}
void solve()
{
    for(long long i = 1; i <= n; i ++)
    {
        if(used[i]) continue;
        children.push(i);
    }

    long long sizy = children.size();
    for(long long i = 0; i < sizy; i ++)
    {
        bfs();

    }
}

void biggestpar(long long node, long long l, long long r, long long &sumans)
{
    if(node == 1)
    {
        if(sumans < 0 && node >= l && node <= r && nody[node] == 0)
        {
            nody[node] = 1;
            sumans = sum[node];
        }
        else if(sumans < 0 && node >= l && node <= r && nody[node] == 1)
        {
            sumans = 0;
        }
        return;
    }

    biggestpar(par[node], l, r, sumans);
    if(sumans > -1) return;
    if(node >= l && node <= r && nody[node] == 1 && sumans < 0)
    {
        sumans = 0;
    }
    if(node >= l && node <= r && nody[node] == 0 && sumans < 0)
    {
         sumans = sum[node];
        nody[node] = 1;
    }
}
void OutPut()
{
    long long ans = 0;
    for(long long i = 1; i <= n; i ++)
    {
        ans += sum[i];
        for(long long j = i+1; j <= n; j ++)
        {
            memset(nody, 0, sizeof(nody));
            for(long long p = i; p <= j; p ++)
            {
                long long teksum = -1;

                biggestpar(p, i, j, teksum);
                if(teksum < 0) teksum = 0;
                ans += teksum;


            }
        }

    }
    cout << ans << endl;
}
int main ()
{
    FastIO();
    InPut();
    solve();
    OutPut();
}

/*
InPut:
6
5 5 1 1 4

OutPut:
87

InPut:
6
1 1 2 2 3

OutPut:
82

InPut:
7
7 7 6 6 1 1

OutPut:
120
*/
