#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

int n, m;
const int MAXN = 5000 + 2;

long long dp[MAXN][MAXN];

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    cin >> n >> m;

    for (int i = 1; i <= n; i++)
    {
        for (int j = 1; j <= n; j++)
        {
            if (i != j) dp[i][j] = 2e9;
        }
    }

    for (int i = 1; i <= m; i++)
    {
        int u, l, r;
        cin >> u >> l >> r;
        for (int v = l; v <= r; v++)
        {
            long long w = v - l + 1;
            dp[u][v] = min(w, dp[u][v]);
        }
    }

    for (int i = 1; i <= n; i++)
    {
        for (int j = 1; j <= n; j++)
        {
            for (int k = 1; k <= n; k++)
            {
                dp[i][j] = min(dp[i][j], dp[i][k] + dp[k][j]);
            }
        }
    }

    for (int i = 1; i <= n; i++)
    {
        cout << (dp[1][i] < 2e9 ? dp[1][i] : -1) << " ";
    }
    cout << endl;

    return 0;
}
/**
10 5
1 1 2
1 8 9
1 7 8
9 3 4
9 3 4

0 2 3 4 -1 -1 1 1 2 -1

*/