#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

int n, k;
int tree[400005][3];
int lazy[400005];
int ans[400005];
vector<pair<int, int> > upd[400005];
int MAXV=1e5+8;

void build_tree(int v, int le, int ri)
{
    if(le==ri)
    {
        if(le==1) tree[v][0]=0;
        else tree[v][0]=MAXV;
        tree[v][1]=le;
        tree[v][2]=le;
        lazy[v]=MAXV;
        return;
    }
    int mid=(le+ri)/2;

    build_tree(2*v, le, mid);
    build_tree(2*v+1, mid+1, ri);

    lazy[v]=MAXV;
    if(tree[2*v][0]<tree[2*v+1][0])
    {
        tree[v][0]=tree[2*v][0];
        tree[v][1]=tree[2*v][1];
    }
    else
    {
        tree[v][0]=tree[2*v+1][0];
        tree[v][1]=tree[2*v+1][1];
    }
    tree[v][2]=tree[2*v][2];
}

void push_lazy(int v, int le, int ri)
{
    ///cout<<le<<" "<<ri<<" "<<lazy[v]<<endl;
    if(lazy[v]==MAXV || tree[v][2]>ri) return;

    int nlidx=tree[v][2], nval=lazy[v]+nlidx-le;

    if(nval<tree[v][0])
    {
        tree[v][0]=nval;
        tree[v][1]=nlidx;
    }

    if(le!=ri)
    {
        int mid=(le+ri)/2;
        lazy[2*v]=min(lazy[v], lazy[2*v]);
        lazy[2*v+1]=min(lazy[v]+mid+1-le, lazy[2*v+1]);
    }
    lazy[v]=MAXV;

}

void block_vert(int v, int le, int ri, int idx)
{
    push_lazy(v, le, ri);
    if(le>idx || ri<idx) return;
    if(le==ri)
    {
        tree[v][0]=MAXV;
        tree[v][1]=ri+1;
        tree[v][2]=ri+1;
        return;
    }
    int mid=(le+ri)/2;
    block_vert(2*v, le, mid, idx);
    block_vert(2*v+1, mid+1, ri, idx);
    if(tree[2*v][2]==mid+1)
    {
        tree[v][0]=tree[2*v+1][0];
        tree[v][1]=tree[2*v+1][1];
        tree[v][2]=tree[2*v+1][2];
    }
    else
    {
        tree[v][2]=tree[2*v][2];
        if(tree[2*v][0]<tree[2*v+1][0])
        {
            tree[v][0]=tree[2*v][0];
            tree[v][1]=tree[2*v][1];
        }
        else
        {
            tree[v][0]=tree[2*v+1][0];
            tree[v][1]=tree[2*v+1][1];
        }
    }
}

void update(int v, int le, int ri, int be, int en, int st)
{
    push_lazy(v, le, ri);
    if(le>en || ri<be) return;
    if(be<=le && ri<=en)
    {
        lazy[v]=st+le-be;
        push_lazy(v, le, ri);
        return;
    }
    int mid=(le+ri)/2;
    update(2*v, le, mid, be, en, st);
    update(2*v+1, mid+1, ri, be, en, st);
    if(tree[2*v][2]==mid+1)
    {
        tree[v][0]=tree[2*v+1][0];
        tree[v][1]=tree[2*v+1][1];
        tree[v][2]=tree[2*v+1][2];
    }
    else
    {
        tree[v][2]=tree[2*v][2];
        if(tree[2*v][0]<tree[2*v+1][0])
        {
            tree[v][0]=tree[2*v][0];
            tree[v][1]=tree[2*v][1];
        }
        else
        {
            tree[v][0]=tree[2*v+1][0];
            tree[v][1]=tree[2*v+1][1];
        }
    }
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>k;
    for(int i=2; i<=n; i++) ans[i]=-1;
    for(int i=0; i<k; i++)
    {
        int u, l, r;
        cin>>u>>l>>r;
        upd[u].push_back({l, r});
    }
    for(int i=0; i<400005; i++) lazy[i]=MAXV;
    build_tree(1, 1, n);
    for(int i=1; i<=n; i++)
    {
        int d=tree[1][0], v=tree[1][1];
        ///cout<<v<<" "<<d<<endl;
        if(d>n || tree[1][2]>n) break;
        ans[v]=d;
        block_vert(1, 1, n, v);
        int bru=upd[v].size();

        for(int i=0; i<bru; i++)
        {
            int be=upd[v][i].first, en=upd[v][i].second;
            ///cout<<be<<" "<<en<<" "<<d+1<<endl;
            update(1, 1, n, be, en, d+1);
        }
    }
    cout<<0;
    for(int i=2; i<=n; i++) cout<<" "<<ans[i];
    cout<<endl;
    return 0;
}
