#include <iostream>
#include <vector>

using namespace std;

/*
10 5
1 1 2
1 8 9
1 7 8
9 3 4
9 3 4
*/

struct Edge {
    int from, to, weight;

public:
    void setPoints(int f, int t) {
        from = f;
        to = t;
    }
    void setWeight(int val) {
        weight = val;
    }
};

int N, M;

vector<Edge> edges;

void createEdges(int u, int l, int r) {
    for(int v = l, w = 1; v <= r; v++, w++) {
        Edge edgeV;

        edgeV.setPoints(u, v);
        edgeV.setWeight(w);

        edges.push_back(edgeV);
    }
}

void displayEdges() {
    for (int i = 0; i < edges.size(); i++) {
        printf("Edge %d is connected to edge %d with weight %d \n", edges[i].from, edges[i].to, edges[i].weight);
    }
}

vector<Edge> getEdges(int from) {
    vector<Edge> e;

    for (int i = 0; i < edges.size(); i++) {
        if (edges[i].from == from) {
            e.push_back(edges[i]);
        }
    }

    return e;
}

vector<Edge> getShortestRoute(int target) {
    vector<Edge> shortestRoute;

    vector<Edge> edgesFrom1 = getEdges(1);

    int from = 2;

    vector<Edge> currRoute;
    vector<Edge> edgesFromPoint = getEdges(from);

    while (edgesFromPoint.size() != 0) {
        for (int i = 0; i < edgesFromPoint.size(); i++) {
            if (edgesFromPoint[i].to == target) {
                currRoute.push_back(edgesFromPoint[i]);
            }
        }
    }


//    for (int i = 0; i < getEdges(1).size(); i++) {
//        for (int j = 0; j < getEdges(edgesFrom1[i]); j++) {
//            for (int k = 0; k < getEdges(getEdges(edgesFrom1[i])); k++) {
//
//            }
//        }
//    }

    return shortestRoute;
}

int main() {
    cin >> N >> M;

    for (int m = 0; m < M; m++) {
        int u, l, r;

        cin >> u >> l >> r;

        createEdges(u, l, r);


    }

    displayEdges();

    return 0;
}
