#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
const long long maxn=1e5+10;
const long long INF=1e9;
vector<pair<long long,long long>> inter[maxn];
struct node
{
    long long v,t;
    node(long long _v, long long _t)
    {
        v=_v;
        t=_t;
    }
};
vector<node> g[maxn];
long long countI[maxn];
long long dist[maxn];
bool used[maxn];
long long n,m;
void dijkstra(long long vr)
{
    priority_queue<pair<long long,long long>> pq;
    pq.push({0,vr});
    for(long long i=1;i<=n;i++)
    {
        dist[i]=INF;
    }
    dist[vr]=0;
    while(!pq.empty())
    {
        vr=pq.top().second;
        //cout<<vr<<endl;
        pq.pop();
        used[vr]=1;
        for(long long i=0;i<g[vr].size();i++)
        {
            if(used[g[vr][i].v])continue;
            if(dist[g[vr][i].v]>dist[vr]+g[vr][i].t)
            {
                dist[g[vr][i].v]=dist[vr]+g[vr][i].t;
                pq.push({-dist[g[vr][i].v],g[vr][i].v});
            }
        }
    }
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);


    cin>>n>>m;

    for(long long i=0;i<m;i++)
    {
        long long u,l,r;
        cin>>u>>l>>r;
        inter[u].push_back({l,r});
    }
    for(long long i=1;i<=n;i++)
    {
        sort(inter[i].begin(),inter[i].end());
    }
    for(long long i=1;i<=n;i++)
    {
        //cout<<i<<endl;
        if(inter[i].size()==0)continue;
        long long ind=0;
        long long k=0;
        countI[0]=1;
        for(long long j=inter[i][ind].first;j<=n;j++)
        {
            if(ind!=inter[i].size()-1&&j==inter[i][ind+1].first)
            {
                ind++;
                k=ind;
                countI[k]=1;
            }
            if(j>inter[i][k].second)
            {
                if(k==0)
                {
                    if(ind==inter[i].size()-1)break;
                    ind++;
                    k=ind;
                    countI[k]=1;
                    j=inter[i][k].first-1;
                    continue;
                }
                else{
                    k--;
                    continue;
                }
            }

            //cout<<i<<" "<<j<<" "<<countI[k]<<endl;
            g[i].push_back({j,countI[k]++});
        }
    }
    dijkstra(1);
        for(long long i=1;i<=n;i++)
    {
        if(i>1)cout<<" ";
        if(dist[i]==INF)cout<<-1;
        else cout<<dist[i];
    }
    cout<<endl;
}
