#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
const long long maxn=1e5+10;

struct treeNode{
    long long a[2];
    long long p=0;
}tree[4*maxn];
long long lazy[4*maxn];
struct numbers{
    long long a, ind1,ind2;
}nums[maxn];
vector<long long> ans;
void build(long long vr, long long l, long long r)
{
    //cout<<
    if(l==r)
    {
        tree[vr].a[0]=nums[2*l].a;
        tree[vr].a[1]=nums[2*l+1].a;
        return;
    }
    long long mid=(l+r)>>1;
    build(2*vr,l,mid);
    build(2*vr+1,mid+1,r);
    tree[vr].a[0]=tree[2*vr].a[0]+tree[2*vr+1].a[0];
    tree[vr].a[1]=tree[2*vr].a[1]+tree[2*vr+1].a[1];
}
void push_lazy(long long vr, long long l, long long r)
{
    if(lazy[vr]==0)return;
    tree[vr].p^=1;
    if(l!=r)
    {
        lazy[2*vr]^=1;
        lazy[2*vr+1]^=1;
    }
    lazy[vr]=0;
}
void point_update(long long vr, long long l ,long long r, long long p, long long k)
{

    push_lazy(vr,l,r);
    if(p<l||p>r)return;
    if(l==r)
    {
        if(k)tree[vr].a[1]=0;
        else {tree[vr].a[0]=0;tree[vr].p^=1;}
        return;
    }
    long long mid=(l+r)>>1;
    point_update(2*vr,l,mid,p,k);
    point_update(2*vr+1,mid+1,r,p,k);
    tree[vr].a[tree[vr].p]=tree[2*vr].a[tree[2*vr].p]+tree[2*vr+1].a[tree[2*vr+1].p];
    tree[vr].a[tree[vr].p^1]=tree[2*vr].a[tree[2*vr].p^1]+tree[2*vr+1].a[tree[2*vr+1].p^1];
}

void range_update(long long vr, long long l, long long r, long long L, long long R)
{
    if(r<L || l>R)return;
    push_lazy(vr,l,r);
    if(L<=l && R>=r)
    {
        lazy[vr]=1;
        push_lazy(vr,l,r);
        return;
    }
    long long mid=(l+r)>>1;
    range_update(2*vr,l,mid,L,R);
    range_update(2*vr+1,mid+1,r,L,R);
    tree[vr].a[tree[vr].p]=tree[2*vr].a[tree[2*vr].p]+tree[2*vr+1].a[tree[2*vr+1].p];
    tree[vr].a[tree[vr].p^1]=tree[2*vr].a[tree[2*vr].p^1]+tree[2*vr+1].a[tree[2*vr+1].p^1];
}
bool cmp1(numbers a, numbers b)
{
    return a.a<b.a;
}
bool cmp2(numbers a, numbers b)
{
    return a.ind1<b.ind1;
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    long long n,k;
    cin>>n>>k;

    for(long long i=0;i<n;i++)
    {
        cin>>nums[i].a;
        nums[i].ind1=i;
    }
    sort(nums,nums+n,cmp1);
    build(1,0,(n+1)/2-1);
    for(long long i=0;i<n;i++)
    {
        nums[i].ind2=i;
    }
    sort(nums,nums+n,cmp2);
      /*  for(long long i=1;i<=4*n;i++)
        {
            cout<<tree[i].a[0]<<" "<<tree[i].a[1]<<" "<<tree[i].p<<endl;
        }*/
    //cout<<nums[n-1].ind2<<endl;
    for(long long i=n-1;i>=0;i--)
    {
        ans.push_back(tree[1].a[tree[1].p]);
        //cout<<"--"<<nums[i].a<<endl;
        point_update(1,0,(n+1)/2-1,nums[i].ind2/2,nums[i].ind2%2);
        /*for(long long i=1;i<=4*n;i++)
        {
            cout<<tree[i].a[0]<<" "<<tree[i].a[1]<<" "<<tree[i].p<<endl;
        }
        cout<<"!!"<<endl;*/
        range_update(1,0,(n+1)/2-1,nums[i].ind2/2+1,(n+1)/2-1);
        /*for(long long i=1;i<=4*n;i++)
        {
            cout<<tree[i].a[0]<<" "<<tree[i].a[1]<<" "<<tree[i].p<<endl;
        }*/
    }
    for(long long i=ans.size()-1;i>=0;i--)
    {
        cout<<ans[i]<<endl;
    }
}
/*
15 2
8 12 7 3 14 25 30 6 7 12 17 31 11 -10 1

*/
