#include<iostream>
#include<algorithm>
#include<cmath>
#include<vector>
#include<chrono>
#include<random>
#include<unordered_map>
#include<queue>
//#include<bits/stdc++.h>
using namespace std;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
static clock_t startT;
double timepassed()
{
    clock_t currT=clock();
    return (double)(currT-startT)/CLOCKS_PER_SEC;
}

const int MAX_N=1e5+5;
int n,m;
unordered_map<int,int>dist[MAX_N];
vector<pair<int,int>>g[MAX_N];
void bfs()
{
    dist[1][0]=0;
    priority_queue<pair<int,pair<int,int>>>q;
    q.push({0,{1,0}});

    while(q.size())
    {
        int u=q.top().second.first;
        int range=q.top().second.second;
        q.pop();

        vector<pair<int,int>>s;
        if(range>u)
        {
            s.push_back({u+1,range});
        }
        for(auto ran:g[u])
        {
            s.push_back(ran);
        }

        for(auto [l,r]:s)
        {
            int x=l;
            if(dist[x].find(r)==dist[x].end() or dist[u][range]+1<dist[x][r])
            {
                dist[x][r]=dist[u][range]+1;

                q.push({-dist[x][r],{x,r}});
            }
        }
    }

    for(int i=1;i<=n;i++)
    {
        if(dist[i].size()==0){cout<<-1<<" ";continue;}
        int mi=1e9;
        for(auto [ran,dis]:dist[i])mi=min(mi,dis);
        cout<<mi<<" ";
    }
    cout<<"\n";
}
int main ()
{
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n>>m;
    for(int i=1;i<=m;i++)
    {
        int u,l,r;
        cin>>u>>l>>r;

        g[u].push_back({l,r});
    }
    bfs();
    return 0;
}
