#include<iostream>
#include<algorithm>
#include<cmath>
#include<vector>
#include<chrono>
#include<random>
using namespace std;
const int MAX_N=1e5+5;
const int MAX_R=320;
int n,k;
int a[MAX_N];

int position[MAX_N];
int val[MAX_N];
int tree[MAX_N];
void Update(int pos)
{
    for(;;)
    {
        if(pos>n)break;
        tree[pos]++;
        pos+=((pos)&(-pos));
    }
}
int kth(int kk)
{
    int sum=0;
    int pos=0;
    for(int j=16;j>=0;j--)
    {
        if(pos+(1<<j)>n)continue;
        if(sum+tree[pos+(1<<j)]<kk)
        {
            pos+=(1<<j);
            sum+=tree[pos];
        }
    }
    return pos+1;
}
void solvebig()
{
    for(int i=1;i<=n;i++)
    {
        Update(position[i]);
        int pos=1;
        long long ans=0;
        while(pos<=n)
        {
            ans+=val[kth(pos)];
            pos+=k;
        }
        cout<<ans<<"\n";
    }
}

bool used[MAX_N];
int cnt[MAX_R+5];
long long cntk[MAX_R+5][MAX_R+5];
int sz=MAX_R;
void buildblock(int b)
{
    int pos=0;

    for(int k0=0;k0<k;k0++)cntk[b][k0]=0;

    for(int l=b*sz+1;l<=(b+1)*sz;l++)
    {
        if(used[l])
        {
            pos++;
            cntk[b][pos%k]+=val[l];
        }
    }
}
void query()
{
    int mo=0;
    long long ans=0;
    for(int b=0;b<=(n-1)/sz;b++)
    {
        ans+=cntk[b][(1-mo+k)%k];
        mo+=cnt[b];
        mo%=k;
    }
    cout<<ans<<"\n";
}
void solvesmall()
{
    for(int i=1;i<=n;i++)
    {
        used[position[i]]=1;
        int b=(position[i]-1)/sz;
        buildblock(b);
        query();
    }
}
int main ()
{
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);

    cin>>n>>k;
    for(int i=1;i<=n;i++)
    {
        cin>>a[i];
    }

    vector<pair<int,int>>v;
    for(int i=1;i<=n;i++)
    {
        v.push_back({a[i],i});
    }
    sort(v.begin(),v.end());

    for(int i=0;i<n;i++)
    {
        position[v[i].second]=i+1;
        val[i+1]=v[i].first;
    }

    if(k<=MAX_R)solvesmall();
    else solvebig();

    return 0;
}
