#include<iostream>
#include<vector>
using namespace std;

int n, m;
vector<pair<int, int> > a[100002];
int price[10002][10002];
int result[100002];

void Read() {
   cin >> n >> m;
   int u, l, r;
   for (int i=0; i<m; i++) {
        cin >> u >> l >> r;
        for (int v=l; v<=r; v++) {
            if (v != u) {
                if (price[u][v] != 0) {
                    if (v - l + 1 < price[u][v]) {
                        price[u][v] = v - l + 1;
                        a[u].push_back({v, v - l + 1});
                    }
                } else a[u].push_back({v, v - l + 1});
            }
        }
   }
}

void DFS(int u, int cost) {
    if (result[u] == 0 || cost < result[u]) result[u] = cost;
    for (int i=0; i<a[u].size(); i++) {
        DFS(a[u][i].first, a[u][i].second + cost);
    }
}

int main() {
    Read();
    DFS(1, 0);
    cout << "0 ";
    for (int i=2; i<=n; i++) {
        if (result[i] == 0) cout << -1 << " ";
        else cout << result[i] << " ";
    } cout << endl;
    return 0;
}
