#include<iostream>
#include<vector>
#include<queue>
using namespace std;

const int INF = 100000000;
int n, m;
vector<pair<int, int> > a[10002];
int price[10002][10002];
pair<int, bool> result[10002];

void Read() {
   cin >> n >> m;
   int u, l, r;
   for (int i=0; i<m; i++) {
        cin >> u >> l >> r;
        for (int v=l; v<=r; v++) {
            if (v != u) {
                if (price[u][v] != 0) {
                    if (v - l + 1 < price[u][v]) {
                        price[u][v] = v - l + 1;
                        a[u].push_back({v, v - l + 1});
                    }
                } else a[u].push_back({v, v - l + 1});
            }
        }
   }
   for (int i=1; i<=n; i++) {
        result[i].first = INF;
   }
}

auto cmp = [](pair<int, int> left, pair<int, int> right) { return left.second < right.second;};


void Dijekstra() {
    result[1].first = 0;
    priority_queue<pair<int, int>, vector<pair<int, int> >, decltype(cmp)> q(cmp);
    q.push({1, 0});
    while (q.size() != 0) {
        int u = q.top().first;
        q.pop();
        if (result[u].second) continue;
        result[u].second = true;
        for (int i=0; i<a[u].size(); i++) {
            pair<int, int> v = a[u][i];
            if (v.second + result[u].first < result[v.first].first) {
                result[v.first].first = v.second + result[u].first;
                if (!result[v.first].second) q.push({v.first, result[v.first].first});
            }
        }
    }
}

int main() {
    Read();
    Dijekstra();
    for (int i=1; i<=n; i++) {
        if (result[i].first == INF) cout << -1 << " ";
        else cout << result[i].first << " ";
    } cout << endl;
    return 0;
}
