#include <iostream>
#include <vector>
#include <queue>
using namespace std;

int n;
vector<int> v[100001];
int p[100001];
int sum = 0;
int used[100001];

void read(){
    cin >> n;
    for(int i = 0; i < n-1; i++){
        cin >> p[i];
        v[p[i]].push_back(i+2);
    }
}

void bfs(int beg){
    queue<int> q;
    q.push(beg);
    sum ++;
    used[beg] = 1;

    while(!q.empty()){
        int w = q.front();
        q.pop();
        for(int i = 0; i < v[w].size(); i++){
            if(!used[v[w][i]]){
                q.push(v[w][i]);
                sum ++;
                used[v[w][i]] = 1;
            }
        }
    }
}

int main(){
    read();
    for(int i = 1; i <= n; i++){
        for(int j = i; j <=n; j++){
            bfs(i);
            bfs(j);
        }
    }
    cout << sum + 8*(n-1);
    return 0;
}
