#include<iostream>
#include<vector>
#include<cstring>
#define MAXN 1010
using namespace std;
int p[MAXN];
vector<int> edges[MAXN];
bool used[MAXN];
int dfs(int curr, bool on, int l, int r)
{
    int res=0;

    if(l<=curr && curr<=r)on=1;
    if(on)res++;

    for(int i=0;i<edges[curr].size();i++)
    {
        int now=edges[curr][i];
        if(now==p[curr] || used[now])continue;
        res+=dfs(now,on,l,r);
    }
    return res;
}
int main()
{
    int n;
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin>>n;
    for(int i=2;i<=n;i++)
    {
        cin>>p[i];
        edges[p[i]].push_back(i);
    }
    long long ans=0;
    for(int i=1;i<=n;i++)
    {
        for(int j=i;j<=n;j++)
        {
            memset(used,0,MAXN);
            int res=dfs(1,0,i,j);
            ans+=res;
        }
    }
    cout<<ans<<"\n";
}