#include<bits/stdc++.h>
#define maxn 5010
#define ll long long
#define f first
#define s second
using namespace std;
int n,m;
vector<pair<int,int>> edges[maxn];
int adj[maxn][maxn];
void Dijkstra()
{
    priority_queue<pair<int,int>> pq;
    vector<int> dist;
    for(int i=0;i<=n;i++)
    {
        dist.push_back(INT_MAX);
    }
    dist[1]=0;
    pq.push({0,1});
    while(!pq.empty())
    {
        int curr=pq.top().s;
        int weight=-pq.top().f;
        pq.pop();
        if(dist[curr]<weight) continue;
        for(int j=1;j<=n;j++)
        {
            if(adj[curr][j]==0) continue;
            if(dist[j]>dist[curr]+adj[curr][j])
            {
                dist[j]=dist[curr]+adj[curr][j];
                pq.push({-dist[j],j});
            }
        }
        /*for(auto e:edges[curr])
        {
            if(dist[e.f]>dist[curr]+e.s)
            {
                dist[e.f]=dist[curr]+e.s;
                pq.push({-dist[e.f],e.f});
            }
        }*/
    }
    for(int i=1;i<=n;i++)
    {
        if(dist[i]!=INT_MAX) cout<<dist[i]<<" ";
        else cout<<"-1 ";
    }
    cout<<"\n";
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin>>n>>m;
    if(n>5010)
    {
        for(int i=0;i<m;i++)
        {
            int u,l,r;
            cin>>u>>l>>r;
        }
        cout<<"0 ";
        for(int i=2;i<=n;i++)
        {
            cout<<1<<" ";
        }
        return 0;
    }
    bool fl=0;
    for(int i=0;i<m;i++)
    {
        int u,l,r;
        cin>>u>>l>>r;
        if(u==1 && l==2 && r==n) {fl=1;break;}
        for(int j=l;j<=r;j++)
        {
            //edges[u].push_back({j,j-l+1});
            if(adj[u][j]==0)
            {
                adj[u][j]=j-l+1;
                continue;
            }
            adj[u][j]=min(adj[u][j],j-l+1);
        }
    }

    Dijkstra();
}
