#include<bits/stdc++.h>
#define maxn 100010
#define ll long long
#define f first
#define s second
using namespace std;
ll n;
ll par[maxn];
ll sz[maxn];
vector<ll> edges[maxn];
int tree[4*maxn];
int close[maxn];
void update(int idx,int val,int node=1,int l=1,int r=n)
{
    if(idx<l || r<idx) return;
    if(l==r)
    {
        tree[node]=val;
        return;
    }
    int mid=(l+r)/2;
    int left=node*2,right=left+1;
    update(idx,val,left,l,mid);
    update(idx,val,right,mid+1,r);
    tree[node]=tree[left]+tree[right];
}
int query(int ql,int qr,int node=1,int l=1,int r=n)
{
  // printf("in %d %d\n",l,r);
    if(r<ql || qr<l) return 0;
    if(l==r)
    {
        if(tree[node]!=0) return l;
        return 0;
    }
    int mid=(l+r)/2;
    int left=node*2,right=left+1;
    int ans=0;
    if(tree[left]!=0)
    {
        ans=query(ql,qr,left,l,mid);
    }
    if(ans!=0) return ans;
    if(tree[right]!=0)
    {
        ans= query(ql,qr,right,mid+1,r);
    }
    return ans;
}
int timer=1;
int alloc[maxn];
void dfs(ll start,ll parent)
{
    alloc[start]=timer++;
    sz[start]=1;
    close[start]=query(start+1,n);
    update(start,1);
    for(auto e:edges[start])
    {
        if(e==parent) continue;
        dfs(e,start);
        sz[start]+=sz[e];
    }
    update(start,0);
}
int tree2[4*maxn];
bool lazy[4*maxn];
void pushLazy(int node,int l,int r)
{
    if(lazy[node])
    {
        tree2[node]=0;
        if(l!=r)
        {
            lazy[node*2]=1;
            lazy[node*2+1]=1;
        }
    }
    lazy[node=0];
}
void update21(int idx,int val,int node=1,int l=1,int r=n)
{
    pushLazy(node,l,r);
    if(idx<l || r<idx) return;
    if(l==r)
    {
        tree2[node]=val;
        return;
    }
    int mid=(l+r)/2;
    int left=node*2,right=left+1;
    update21(idx,val,left,l,mid);
    update21(idx,val,right,mid+1,r);
    tree2[node]=tree2[left]+tree2[right];
}
int query2(int ql,int qr,int node=1,int l=1,int r=n)
{
    pushLazy(node,l,r);
    if(r<ql || qr<l) return 0;
    if(ql<=l && r<=qr) return tree2[node];
    int mid=(l+r)/2;
    int left=node*2,right=left+1;
    int ans=0;
    ans+=query2(ql,qr,left,l,mid);
    ans+=query2(ql,qr,right,mid+1,r);
    return ans;
}
void update22(int ul,int ur,int node=1,int l=1,int r=n)
{
    if(r<ul || ur<l) return;
    if(ul<=l && r<=ur)
    {
        tree2[node]=0;
        if(l!=r)
        {
            lazy[node*2]=1;
            lazy[node*2+1]=1;
        }
        return;
    }
    int mid=(l+r)/2;
    int left=node*2,right=left+1;
    update22(ul,ur,left,l,mid);
    update22(ul,ur,right,mid+1,r);
    tree2[node]=tree2[left]+tree2[right];
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin>>n;
    for(ll i=2;i<=n;i++)
    {
        cin>>par[i];
        edges[par[i]].push_back(i);
    }
    dfs(1,1);
    ll ans=n*n;
    ll addon=0;
   // printf("closests:\n");
    for(int i=1;i<=n;i++)
    {
      //  printf("for %d is %d\n",i,close[i]);
    }
    for(int i=n;i>1;i--)
    {
        int p=alloc[i];
        int child=query2(p,p+sz[i]-1);
        if(child) update22(p+1,p+sz[i]-1);
        addon-=child;
      //  printf("for %d child %d size %d\n",i,child,sz[i]);
        if(close[i]!=0)
        {
            addon+=sz[i]*(close[i]-i);
            update21(p,sz[i]*(close[i]-i));
        }
        else
        {
            addon+=sz[i]*(n-i+1);
            update21(p,sz[i]*(n-i+1));
        }
       // printf("for %d addon is %d\n",i,addon);
        ans+=addon;
    }
    cout<<ans<<"\n";
}

