#include<bits/stdc++.h>
using namespace std;
#define BIGINT 2000000000
int n,m;
vector<pair<int,int>> comp[100001];
vector<pair<int,int>> path[100001];
int dist[100001];
void func(){
    for(int i=2;i<=n;i++) dist[i]=BIGINT;
    queue<int> q;
    q.push(1);
    while(!q.empty()){
        int curr=q.front();
        q.pop();
        for(auto p:path[curr]){
            if(dist[curr]+p.second<dist[p.first]){
                q.push(p.first);
                dist[p.first]=dist[curr]+p.second;
            }
        }
    }
}

int main(){
    cin>>n>>m;
    for(int i=0;i<m;i++){
        int u,l,r;
        cin>>u>>l>>r;
        comp[u].push_back({l,r});
    }
    for(int u=1;u<=n;u++){
        sort(comp[u].begin(),comp[u].end());
        comp[u].push_back({100001,100001});
        int k=0;
        for(int v=comp[u][k].first;v<=n;v++){
            while(v>=comp[u][k+1].first) k++;
            if(v>comp[u][k].second) continue;
            path[u].push_back({v,v-comp[u][k].first+1});
            //printf("path from %d to %d with weight %d, k = %d\n",u,v,v-comp[u][k].first+1,k);
        }
    }
    func();
    for(int i=1;i<=n;i++){
        if(dist[i]==BIGINT) dist[i]=-1;
        cout<<dist[i]<<' ';
    }
}
