#include<bits/stdc++.h>
using namespace std;
#define BIGINT 2000000000
int n,m;
vector<pair<int,int>> comp[100001];
vector<tuple<int,int,int>> comp2[100001];
int dist[100001];
void func(){
    for(int i=2;i<=n;i++) dist[i]=BIGINT;
    queue<int> q;
    q.push(1);
    while(!q.empty()){
        int curr=q.front();
        q.pop();
        for(auto c:comp2[curr]){
            for(int v=get<0>(c);v<=get<1>(c);v++){
                int w=v-get<0>(c)+get<2>(c);
                //printf("Process path (%d,%d) with w = %d\n",curr,v,w);
                if(dist[curr]+w<dist[v]){
                    dist[v]=dist[curr]+w;
                    q.push(v);
                    //printf("Push %d, dist = %d\n",v,dist[v]);
                }
            }
        }
    }
}

int main(){
    cin>>n>>m;
    for(int i=0;i<m;i++){
        int u,l,r;
        cin>>u>>l>>r;
        comp[u].push_back({l,r});
    }
    for(int u=1;u<=n;u++){
        sort(comp[u].begin(),comp[u].end());
        comp[u].push_back({100001,100001});
        for(int k=0;k<comp[u].size()-1;k++){
                if(comp[u][k].first<comp[u][k+1].first){
                    comp2[u].push_back({comp[u][k].first,min(comp[u][k].second,comp[u][k+1].first-1),1});
                    //printf("Comp2[%d] push (%d,%d,%d) front cut\n",u,comp[u][k].first,min(comp[u][k].second,comp[u][k+1].first-1),1);
                    if(comp[u][k].second>comp[u][k+1].second){
                        comp2[u].push_back({comp[u][k+1].second+1,comp[u][k].second,comp[u][k+1].second-comp[u][k].first+2});
                        //printf("Comp2[%d] push (%d,%d,%d) back cut\n",u,comp[u][k+1].second+1,comp[u][k].second,comp[u][k+1].second-comp[u][k].first+2);
                    }
                }
        }
    }
    func();
    for(int i=1;i<=n;i++){
        if(dist[i]==BIGINT) dist[i]=-1;
        cout<<dist[i]<<' ';
    }
}
