#include <bits/stdc++.h>
using namespace std;

long long const maxd=2e9, maxn=4e3+3;
long long n,m,dist[maxn],a[maxn][maxn];
//vector<pair<long long,long long>> rebra;
//map<pair<long long,long long>,long long> mp;
vector<pair<long long,long long>> d[maxn];

void dijkstra(){
    priority_queue<pair<long long,long long>> pq;
    pq.push({0,1});
    for(long long i=2;i<=n;i++) dist[i]=maxd;
    while(!pq.empty()){
        long long curr=pq.top().second;
        long long p=-pq.top().first;
        pq.pop();
        if(dist[curr]<p) continue;
        for(auto i: d[curr]){
            if(dist[i.first]>p+i.second){
                dist[i.first]=p+i.second;
                pq.push({-dist[i.first],i.first});
            }
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin>> n >> m;
    for(long long i=0;i<m;i++){
        long long u,l,r;
        cin>> u >> l >> r;
        a[u][l]=r;
    }

    for(int i=1;i<=n;i++){
        vector<int> v;
        int start=0,endd=0;
        for(int j=1;j<=n;j++){
            if(j>endd && endd>0){
                if(!v.empty()) v.pop_back();
                if(v.empty()){
                    start=0;
                    endd=0;
                    continue;
                }
                while(!v.empty()){
                    start=v.back();
                    endd=a[i][v.back()];
                    if(j>endd) v.pop_back();
                }
                if(v.empty()){
                    start=0;
                    endd=0;
                    continue;
                }
            }
            if(a[i][j]!=0){
                v.push_back(j);
                start=j;
                endd=a[i][j];
            }
            if(start==0 && endd==0) continue;
            if(i==j) continue;
            //cout<< i << " " << j << " :: " << j-start+1 << endl;
            d[i].push_back({j,j-start+1});
        }
    }

    dijkstra();
    for(long long i=1;i<=n;i++){
        if(dist[i]==maxd) cout<< -1 << " ";
        else cout<< dist[i] << " ";
    }





    return 0;
}
/*
10 7
1 1 2
1 8 9
1 7 8
9 3 4
9 3 4
3 2 9
2 7 7



*/
