//it is your desire to work hard

#include<bits/stdc++.h>
#define pb push_back
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef complex<double> C;

const int maxn=1e5+3;
const int mod=1e9+7;

int n, m;

vector<pii> edges[maxn];

struct Entry{
    int to, dist;
};

bool operator < (const Entry& l, const Entry& r){
    return l.dist > r.dist;
}

ll dist[maxn];
vector<int> curr_edges;

void get_distances(int x, int y){
    curr_edges.clear();

    /*for(int i=0; i<edges[x].size(); i++){
        if(edges[x][i].first<=y and edges[x][i].second>=y){
            curr_edges.pb(y - edges[x][i].first + 1);
        }

        if(edges[x][i].first>y) break;
    }*/

    int l=0, r=edges[x].size()-1;

    while(l!=r-1){
        int mid=(l+r)/2;

        if(edges[x][mid].first>y){
            r=mid;
        }else{
            l=mid;
        }
    }

    for(int i=l; i>=0; i--){
        if(edges[x][i].first<=y and edges[x][i].second>=y){
            curr_edges.pb(y - edges[x][i].first + 1);
        }
    }

    return ;
}

vector<pii> nbrs[maxn];

int main(){

ios_base::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);

cin>>n>>m;

for(int i=0; i<m; i++){
    int a, l, r;
    cin>>a>>l>>r;

    edges[a].pb({l, r});
}

cerr<<"0s"<<endl;

//for(int i=1; i<=n; i++) sort(edges[i].begin(), edges[i].end());

for(int i=0; i<=n; i++) dist[i]=-1;

for(int i=1; i<=n; i++){
    for(int j=0; j<edges[i].size(); j++){
        for(int k=edges[i][j].first; k<=edges[i][j].second; k++){
            //cerr<<"adding "<<i<<" to "<<k<<" weight "<<k - edges[i][j].first + 1<<endl;
            nbrs[i].pb({k, k - edges[i][j].first + 1});
        }
    }
}

cerr<<"built nbrs"<<endl;

// start Dijkstra
dist[1]=0;
priority_queue<Entry> q;
q.push({1, 0});

while(!q.empty()){
    Entry curr_entry = q.top();
    q.pop();
    int curr=curr_entry.to;
    int curr_dist=curr_entry.dist;

    if(dist[curr]>curr_dist) continue;

    /*for(int i=1; i<=n; i++){
        if(i==curr) continue;

        get_distances(curr, i);

        for(auto w: curr_edges){
            if(dist[i]==-1 or dist[i]>curr_dist + w){
                dist[i]=curr_dist+w;
                q.push({i, dist[i]});
            }
        }
    }*/

    for(int i=0; i<nbrs[curr].size(); i++){
        int to=nbrs[curr][i].first;
        int d=nbrs[curr][i].second;

        if(dist[to]==-1 or dist[to]>curr_dist + d){
            dist[to]=curr_dist+d;
            q.push({to, dist[to]});
        }
    }


}

for(int i=1; i<=n; i++){
    cout<<dist[i]<<" ";
}

return 0;
}

