///Tva reshenie e golqma prostotiq
#include<bits/stdc++.h>
using namespace std;
#define MAXN 100007
#define BUK 300
int ar[MAXN],n,k;
int nv[MAXN];
pair<int,int> zas[MAXN];
int nvpos[MAXN];
long long segAns[4*MAXN];
void UpdateAns(int ind, int l, int r, int ql, int qr, long long klk)
{
    if (ql<=l && qr>=r)
    {
        segAns[ind]+=klk;
        return;
    }
    int mid=(l+r)/2;
    if (ql<=mid) UpdateAns(ind*2,l,mid,ql,qr,klk);
    if (qr>=mid+1) UpdateAns(ind*2+1,mid+1,r,ql,qr,klk);
}
void ShowAns(int ind, int l, int r, long long smm)
{
    smm+=segAns[ind];
    if (l==r)
    {
        cout<<smm<<"\n";
        return;
    }
    int mid=(l+r)/2;
    ShowAns(ind*2,l,mid,smm);
    ShowAns(ind*2+1,mid+1,r,smm);
}
long long segSr[4*MAXN];
void UpdateSr(int ind, int l, int r, int pos)
{
    if (l==r)
    {
        segSr[ind]=1;
        return;
    }
    int mid=(l+r)/2;
    if (pos<=mid) UpdateSr(ind*2,l,mid,pos);
    else UpdateSr(ind*2+1,mid+1,r,pos);
    segSr[ind]=segSr[ind*2]+segSr[ind*2+1];
}
int qusr=0;
void QuerySr(int ind, int l, int r, int ql, int qr)
{
    if (ql<=l && qr>=r)
    {
        qusr+=segSr[ind];
        return;
    }
    int mid=(l+r)/2;
    if (ql<=mid) QuerySr(ind*2,l,mid,ql,qr);
    if (qr>=mid+1) QuerySr(ind*2+1,mid+1,r,ql,qr);
}
int SearchSr(int ind, int l, int r, int klk)
{
    if (l==r) return l;
    int mid=(l+r)/2;
    if (segSr[ind*2]>=klk) return SearchSr(ind*2,l,mid,klk);
    else return SearchSr(ind*2+1,mid+1,r,klk-segSr[ind*2]);
}
int bigK()
{
    for (int q=1;q<=n;q++)
    {
        nvpos[ nv[q] ]=q;
    }
    for (int q=1;q<=n;q++)
    {
        qusr=0;
        QuerySr(1,1,n,1,nvpos[q]);
        int a;
        if (qusr%k==0) a=qusr/k;
        else a=(qusr/k)+1;
        UpdateSr(1,1,n,nvpos[q]);
        for (a=a;true;a++)
        {
            int pos=a*k+1;
            if (pos>n || pos>q) break;
            int lgr=SearchSr(1,1,n,pos);
            if (lgr<nvpos[q]) lgr=nvpos[q];
            int rgr;
            if (pos==q) rgr=n;
            else rgr=SearchSr(1,1,n,pos+1)-1;
            //cout<<q<<" "<<ar[ nvpos[q] ]<<" "<<pos<<" "<<lgr<<" "<<rgr<<"\n";
            UpdateAns(1,1,n,lgr,rgr,ar[ nvpos[q] ]);
        }
    }
    ShowAns(1,1,n,0);
    return 0;
}
int smallK();
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n>>k;
    for (int q=1;q<=n;q++)
    {
        cin>>ar[q];
        zas[q].first=ar[q];
        zas[q].second=q;
    }
    sort(zas+1,zas+n+1);
    for (int q=1;q<=n;q++) nv[ zas[q].second ]=q;
    //for (int q=1;q<=n;q++) cout<<nv[q]<<" ";
    if (k>BUK) return bigK();
    return smallK();
}
long long seg[4*MAXN][BUK],sbr[4*MAXN];
void Merge(int ind)
{
    sbr[ind]=sbr[ind*2]+sbr[ind*2+1];
    for (int q=0;q<k;q++)
    {
        seg[ind][q]=seg[ind*2][q]+seg[ind*2+1][ (q+(sbr[ind*2]))%k ];
    }
}
void Update(int ind, int l, int r, int pos, long long ch)
{
    if (l==r)
    {
        sbr[ind]++;
        seg[ind][0]=ch;
        return;
    }
    int mid=(l+r)/2;
    if (pos<=mid) Update(ind*2,l,mid,pos,ch);
    else Update(ind*2+1,mid+1,r,pos,ch);
    Merge(ind);
}
int smallK()
{
    for (int q=1;q<=n;q++)
    {
        Update(1,1,n,nv[q],ar[q]);
        cout<<seg[1][0]<<"\n";
    }
    return 0;
}
