#include<iostream>
#define endl '\n'
using namespace std;
long long n,k,a,sum[3],start=1,fen[100005];
bool lazy[500005];
long long tree[500005][3];
void update(long long t)
{
    for(long long i=t;i<=n;i+= (i & -i))
    {
        fen[i]++;
    }
}
void updateint(int node,int l,int r,int le,int ri)
{
    if(l>=le && r<=ri)
    {
        lazy[node]=!lazy[node];
    }
    if(lazy[node]==1)
    {
        swap(tree[node][0],tree[node][1]);
        if(l!=r)
        {
            lazy[2*node]=!lazy[2*node];
            lazy[2*node+1]=!lazy[2*node+1];
        }
    }
    if(l>=le && r<=ri) return;
    if(l>ri || r<le) return;

    int mid=(l+r)/2;
    updateint(2*node,l,mid,le,ri);
    updateint(2*node+1,mid+1,r,le,ri);

    tree[node][0]=tree[2*node][0]+tree[2*node+1][0];
    tree[node][1]=tree[2*node][1]+tree[2*node+1][1];
}
void updatenum(int node,int l,int r,long long val,bool isch)
{
    if(lazy[node]==1)
    {
        swap(tree[node][0],tree[node][1]);
        if(l!=r)
        {
            lazy[2*node]=!lazy[2*node];
            lazy[2*node+1]=!lazy[2*node+1];
        }
    }
    if(l>val || r<val) return;

    if(l==r)
    {
        tree[node][isch]+=val;
        return;
    }
     int mid=(l+r)/2;
     updatenum(2*node,l,mid,val,isch);
     updatenum(2*node+1,mid+1,r,val,isch);

     tree[node][0]=tree[2*node][0]+tree[2*node+1][0];
     tree[node][1]=tree[2*node][1]+tree[2*node+1][1];
}
long long qsum()
{
    if(lazy[1]==1)
    {
        swap(tree[1][0],tree[1][1]);
        lazy[2]=!lazy[2];
        lazy[3]=!lazy[3];

    }
    return tree[1][0];
}
int query(long long n)
{
    int pos=0;
    for(long long i=n;i>=1;i-= (i & -i))
    {
        pos+=fen[i];
    }
    return pos;
}
int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>k;

    long long p,s;
    bool isch;

    for(int i=0;i<n;i++)
    {
        cin>>a;
        int p=query(a);

        p++;
        if(p%k==1) isch=0;
        else isch=1;

        updatenum(1,1,n,a,isch);
        updateint(1,1,n,a+1,n);

        cout<<qsum()<<endl;
        update(a);
    }


}

