#include <bits/stdc++.h>
using namespace std;

template< class T, class T2 > inline bool chkmin( T& a, const T2& b ){ return a > b ? a = b, 1 : 0; }

#ifndef LOCAL
define cerr if( false ) cerr
#endif

#define out( x ) #x << " = " << x << "  "
#define endl "\n"

typedef long long ll;

const int MAX_N =  4e3 + 42;
const int mod = 1e9 + 7;

ll dist[MAX_N][MAX_N];
ll d[MAX_N];

std::vector< std::pair< int, int > > v[MAX_N];

int main(){
#ifndef LOCAL
std::ios_base::sync_with_stdio(false); std::cin.tie( NULL ); std::cout.tie( NULL );
#endif

    int n, m;
    std::cin >> n >> m;

    for( int i=0 ; i < n ; i++ ){
        for( int j=0 ; j < n ; j++ ) dist[i][j] = mod;
    }

    for( int i=0 ; i < m ; i++ ){
        int a, l, r;
        std::cin >> a >> l >> r;
        a--; l--; r--;
        for( int j=l ; j <= r ; j++ ) chkmin( dist[a][j], j - l + 1 );
    }

    for( int i=0 ; i < n ; i++ ){
        for( int j = 0 ; j < n ; j++ ){
            v[i].push_back({ j, dist[i][j] } );
        }
    }

    for( int i=0 ; i < n ; i++ ) d[i] = mod;

    std::priority_queue< std::pair< int, int > > q;
    q.push({ 0, 0 });
    d[0] = 0;
    while( !q.empty() ){
        auto curr = q.top();
        q.pop();
        curr.first *= -1;

        cerr << out( curr.first ) << out( curr.second ) << endl;

        for( auto j : v[curr.second] ){
            int currDist = d[ curr.second ] + j.second;
            if( chkmin( d[j.first], currDist ) ){
                q.push({ -currDist, j.first });
            }
        }
    }

    for( int i=0 ; i < n ; i++ ){
        std::cout << ( d[i] == mod ? -1 : d[i] ) << " ";
    }
    std::cout << endl;

    return 0;
}
