#include <bits/stdc++.h>
using namespace std;

template< class T, class T2 > inline bool chkmin( T& a, const T2& b ){ return a > b ? a = b, 1 : 0; }
template< class T, class T2 > inline bool chkmax( T& a, const T2& b ){ return a < b ? a = b, 1 : 0; }


#ifndef LOCAL
#define cerr if( false ) cerr
#endif

#define out( x ) #x << " = " << x << "  "
#define endl "\n"

typedef long long ll;
#define int ll

const int MAX_N =  1e5 + 42;
const int mod = 1e9 + 7;

std::vector< int > v[MAX_N];
int p[MAX_N];

int sz[MAX_N];
void dfs( int x = 0, int par = -1 ){
    sz[x] =1;
    for( auto j : v[x] ){
        if( j == par ) continue;
        dfs( j, x );
        sz[x] += sz[j];
    }

    //cerr << out( x ) << out( sz[x] ) << endl;
}



int mn[MAX_N];
int mx[MAX_N];

std::set< int > s;

void dfs2( int x = 0, int par = -1 ){

    auto it = s.lower_bound( x );
    mx[x] = *it;
    it = prev( it );
    mn[x] = *it;

    cerr << out( x ) << endl;
    for( auto j : s ) cerr << j << " ";
    cerr << endl;
    cerr << out( mn[x] ) << out( mx[x] ) << endl << endl;

    s.insert( x );

    for( auto j : v[x] ){
        cerr << out( j ) << endl;
        if( j == par ) continue;
        dfs2( j, x );
    }

    it = s.find( x );
    if( it != s.end() ) s.erase( it );

}


signed main(){
#ifndef LOCAL
std::ios_base::sync_with_stdio(false); std::cin.tie( NULL ); std::cout.tie( NULL );
#endif

    int n;
    std::cin >> n;

    for( int i=1 ; i < n ; i++ ){
        std::cin >> p[i];
        p[i] --;
        v[p[i]].push_back( i );
    }

    dfs( );

    s.insert( -1 );
    s.insert( n );

    for( int i=0 ; i < n ; i++ ){
        mn[i] = 0;
        mx[i] = n-1;
    }
    dfs2( );

    ll nas = 0;
    for( int i=0 ; i < n ; i++ ){
        //chkmax( mn[i], 0 );
        //chkmin( mx[i], n-1 );
        cerr << out( i ) << out( mx[i] ) << out( mn[i] ) << endl;
        ll left = ( i - mn[i] );
        ll right = ( mx[i] - i );
        cerr << out( left ) << out( right ) << endl;
        nas += left * right * sz[i];
    }

    std::cout << nas << endl;


    return 0;
}
