#include<bits/stdc++.h>
#define MAXN 100007
using namespace std;

int n,par[MAXN];
vector<int> v[MAXN];
long long ans;

struct comps{
    set<int> s;
    long long res;

    long long comb(long long x){
        return x*(x-1)/2 + x;
    }

    void init(){
        s.insert(0);
        s.insert(n+1);
        res=comb(n);
    }

    void add(int x){
        s.insert(x);
        auto it=s.find(x);

        it--;
        int l=*it;
        it++; it++;
        int r=*it;

        res-=comb(r-l-1);
        res+=comb(r-x-1);
        res+=comb(x-l-1);
    }

    void rem(int x){
        auto it=s.find(x);

        it--;
        int l=*it;
        it++; it++;
        int r=*it;

        res+=comb(r-l-1);
        res-=comb(r-x-1);
        res-=comb(x-l-1);

        s.erase(x);
    }
}path;

void dfs(int x){
    path.add(x);

    ans+=path.comb(n) - path.res;
    cout<<x<<" "<<path.comb(n) - path.res<<"\n";

    for(int i:v[x])dfs(i);

    path.rem(x);
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n;

    for(int i=2;i<=n;i++){
        cin>>par[i];

        v[par[i]].push_back(i);
    }

    path.init();
    dfs(1);

    cout<<ans<<"\n";

    return 0;
}