#include<bits/stdc++.h>
#define MAXN 100007
using namespace std;

int n,k,a[MAXN],bigk;

vector<int> w;
unordered_map<int,int> mp;
int cnt,ret[MAXN];

struct ost{
    long long r[72];
    int sum;
};

struct SegmentTree{
    int tree[4*MAXN];

    ost t[4*MAXN];

    void update(int v,int l,int r,int pos){
        if(l==r){
            tree[v]++;
            return;
        }

        int tt=(l+r)/2;
        if(pos<=tt)update(2*v,l,tt,pos);
        else update(2*v+1,tt+1,r,pos);

        tree[v]++;
    }

    void upgrade(int v,int l,int r,int pos){
        if(l==r){
            t[v].r[t[v].sum%k]+=ret[l];
            t[v].sum++;
            return;
        }

        int tt=(l+r)/2;
        if(pos<=tt)upgrade(2*v,l,tt,pos);
        else upgrade(2*v+1,tt+1,r,pos);

        for(int s=0;s<k;s++){
            t[v].r[s]=t[2*v].r[s] + t[2*v+1].r[(s+t[2*v].sum)%k];
        }
        t[v].sum++;
    }

    long long calc(int v,int l,int r,int w){
        if(tree[v]<w+1)return 0;

        if(l==r){
            return (tree[v]/k + (tree[v]%k)>=w+1) * ret[l];
        }

        int tt=(l+r)/2;
        return calc(2*v,l,tt,w) + calc(2*v+1,tt+1,r,(w-tree[2*v]%k+k)%k);
    }
}tree;

void compress(){
    sort(w.begin(),w.end());

    for(int i=0;i<w.size();i++){
        if(i==0 or w[i]!=w[i-1])cnt++;
        mp[w[i]]=cnt; ret[cnt]=w[i];
    }

    for(int i=1;i<=n;i++){
        a[i]=mp[a[i]];
    }
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>k;
    bigk=max(int(sqrt(n)),70);

    for(int i=1;i<=n;i++){
        cin>>a[i];
        w.push_back(a[i]);
    }

    compress();

    for(int i=1;i<=n;i++){
        if(k>bigk)tree.update(1,1,cnt,a[i]);
        else tree.upgrade(1,1,cnt,a[i]);

        if(k>bigk)cout<<tree.calc(1,1,cnt,0)<<"\n";
        else cout<<tree.t[1].r[0]<<"\n";
    }

    return 0;
}