#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

void speed()
{
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);
}

const int MAXN = (int)1e5 + 5;

vector < int > v[MAXN];
int par[MAXN];
int sum[MAXN];
int ans = 0;
int n;

void read()
{
    cin >> n;

    int x;

    for(int i = 2 ; i <= n ; i++)
    {
        cin >> x;

        par[i] = x;

        v[i].push_back(x);
        v[x].push_back(i);
    }
}

void dfs(int node, int parent)
{
    if((int)v[node].size() == 0)
    {
        sum[node] = 1;
        return;
    }

    for(int nb : v[node])
    {
        if(nb == parent)
            continue;

        dfs(nb, node);
        sum[node] += sum[nb];
    }

    sum[node] += 1;
}

int main()
{
    speed();

    read();

    dfs(1, -1);

    /**
    for(int i = 1 ; i <= n ; i++)
        cout << sum[i] << ' ';
    cout << endl;
    **/

    for(int i = 1 ; i <= n ; i++)
    {
        for(int j = i  ; j <= n ; j++)
        {
            //cout << i << ' ' << j <<endl;

            for(int k = i ; k <= j ; k++)
            {
                //cout << "--> " << k << ' ' << par[k] << endl;
                //cout << i << ' ' << j << ' ' << k << endl;
                //dfs(k, par[k]);
                ans += sum[k];
            }
        }
    }

    cout << ans << endl;

    return 0;
}
