#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
const int MAXN = 2e5+10;
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

int n, m;
int a[MAXN];
vector < pair < int, int > > act[MAXN];
void read()
{
    cin >> n >> m;

    for (int i = 1; i <= m; ++ i)
    {
        int u, l, r;
        cin >> u >> l >> r;
        act[u].push_back(make_pair(l, r));
    }
}
vector < pair < int, int > > g[MAXN];

int tonxt[MAXN];

int start[MAXN], finish[MAXN];
void make_graph()
{

    for (int i = 1; i <= n; ++ i)
    {
       for (auto &[l, r]: act[i])
       {
           if(l == i)
           {
               g[l].push_back(make_pair(l+1, 2));
               start[l+1] ++;
           finish[r-1] ++;
           continue;
           }
           g[i].push_back(make_pair(l, 1));
           start[l] ++;
           finish[r-1] ++;
       }


    }
    int cnt = 0;
    for (int i = 1; i <= n; ++ i)
    {
        cnt += start[i];
        if(cnt)tonxt[i] = 1;
        cnt -= finish[i];
    }

}

int used[MAXN];
long long dist[MAXN];

void dijkstra()
{
    for (int i = 1; i <= n; ++ i)
    {
        dist[i] = 1e17;
        used[i] = 0;
    }
    priority_queue < pair < long long, int > > q;
    q.push(make_pair(0, 1));
    dist[1] = 0;
    while(!q.empty())
    {
        int w = q.top().second;
        q.pop();
        if(used[w])continue;
        used[w] = 1;
        if(tonxt[w])
        {
            if(!used[w+1] && dist[w+1] > dist[w] + 1)
            {
                dist[w+1] = dist[w] + 1;
                q.push(make_pair(-dist[w+1], w+1));
            }
        }
        for (auto &[to, cost]: g[w])
        {
            if(!used[to] && dist[to] > dist[w] + cost)
            {
                dist[to] = dist[w] + cost;
                q.push(make_pair(-dist[to], to));
            }
        }
    }
    for (int i = 1; i <= n; ++ i)
    {
        if(dist[i] == 1LL * 1e17)cout << -1 << " ";
        else cout << dist[i] << " ";
    }
    cout << endl;
}
int main()
{
    speed();
    read();
    make_graph();
    dijkstra();
    return 0;
}
