#include<iostream>
#include<bits/stdc++.h>
using namespace std;

struct edge
{
    int v, w;
    bool operator <(const edge& e)const
    {
        return w>e.w;
    }
};
int n, m;
//vector<seg>v[100001];

map<int, int>v2[100001];


void read()
{
    cin>>n>>m;
    int u, _l, _r;
    for(int i = 0; i<m; i++)
    {
        cin>>u>>_l>>_r;
        for(int i=_l;i<=_r;i++)
        {
            auto it = v2[u].find(i);
            if(it==v2[u].end())
            {
                v2[u].insert({i, i-_l+1});
            }
            else
            {
                int val = it->second;
                if(val>i-_l+1)
                {
                    v2[u].erase(it);
                    v2[u].insert({i, i-_l+1});
                }
            }
        }
    }
}

unsigned int d[100001];
void init()
{
    for(int i = 2;i<=n;i++)
    {
        d[i]=-1;
    }
}
bool used[100001];
void Dijkstra()
{
    priority_queue<edge>q;
    q.push({1, 0});
    while(!q.empty())
    {
        edge e = q.top();q.pop();
        if(!used[e.v])
        {
            used[e.v] = 1;
            if(e.w<=d[e.v])
            {
                for(auto nb = v2[e.v].begin(); nb!=v2[e.v].end();++nb)
                {
                    edge _nb;
                    _nb.v = nb->first;
                    _nb.w = e.w + nb->second;
                    if(_nb.w<d[_nb.v])
                    {
                        d[_nb.v] = _nb.w;
                        q.push(_nb);
                    }
                }
            }
        }
    }
}

void print()
{
    for(int i = 1; i<=n; i++)
    {
        if(d[i]==(unsigned int)-1)
        {
            cout<<-1<<" ";
        }
        else cout<<d[i]<<" ";
    }
    cout<<endl;
}

int main()
{
    read();
    init();
    Dijkstra();
    print();
    return 0;
}
