#include <bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

const int MAXN = 1e5 + 10;

int n, p[MAXN];
set < pair < int, int > > act;
ll sigma;

inline ll fun(ll len)
{
    return len * (len + 1) / 2;
}

void insert_element(int idx)
{
    act.insert({idx, idx});
    set < pair < int, int > > :: iterator it = act.find({idx, idx});
    pair < int, int > bef = {-1, -1}, aft = {MAXN, MAXN};
    if (it != act.begin()) bef = *(prev(it));
    if (next(it) != act.end()) aft = *(next(it));

    pair < int, int > cur = {idx, idx};
    if (bef.second == cur.first - 1)
    {
        sigma = sigma - fun(bef.second - bef.first + 1);
        act.erase(act.find(bef));
        cur.first = bef.first;
    }

    if (aft.first == cur.second + 1)
    {
        sigma = sigma - fun(aft.second - aft.first + 1);
        act.erase(act.find(aft));
        cur.second = aft.second;
    }

    act.erase(act.find({idx, idx}));
    act.insert(cur);
    //cout << "INSERT ELEMENT " << idx << " : " << cur.first << " " << cur.second << endl;
    //cout << "bef SIGMA" << sigma << endl;
    sigma += fun(cur.second - cur.first + 1);
    //cout << "SIGMA: " << sigma << endl;
    //cout << "intervals: " << endl;
    //for (pair < int, int > cc : act)
    //{
     //   cout << cc.first << " :: " << cc.second << endl;
    //}
}

void remove_element(int idx)
{
    set < pair < int, int > > :: iterator it = act.lower_bound({idx, MAXN});
    it = prev(it);

    pair < int, int > cur = *it;
    pair < int, int > bef = {cur.first, idx - 1};
    pair < int, int > aft = {idx + 1, cur.second};

    sigma = sigma - fun(cur.second - cur.first + 1);
    act.erase(it);
    if (bef.first <= bef.second)
    {
        sigma += fun(bef.second - bef.first + 1);
        act.insert(bef);
    }

    if (aft.first <= aft.second)
    {
        sigma += fun(aft.second - aft.first + 1);
        act.insert(aft);
    }
}

vector < int > adj[MAXN];
void input()
{
    cin >> n;
    for (int i = 2; i <= n; i ++)
    {
        cin >> p[i];
        adj[p[i]].push_back(i);
    }
}

ll dfs(int v)
{
    remove_element(v);
    /*cout << "in vertex: " << v << endl;
    cout << "active: " << endl;
    for (pair < int, int > cur : act)
            cout << cur.first << " - " << cur.second << endl;
    cout << "sigma: " << sigma << endl;*/
    ll out = sigma;

    for (int u : adj[v])
    {
        out += dfs(u);
    }

    insert_element(v);
    return out;
}

void compute()
{
    sigma = fun(n);
    act.insert({1, n});
    ll res = 0;
    for (ll len = 1; len <= n; len ++)
    {
        ll c = n - len + 1;
        res = res + n * c;
    }

    res = res - dfs(1);

    cout << res << endl;
}
void solve()
{
    input();
    compute();


}

int main()
{
    speed();
    solve();
    return 0;
}
