#include<iostream>
#include <vector>
#include<queue>
using namespace std;
const int INF = 1e9;
int main()
{
	int n, m;
	cin >> n >> m;
	vector<vector<pair<int, int>>>graph(n + 1);
	for (int i = 0; i < m; i++)
	{
		int u, v, t;
		cin >> u >> v >> t;
		graph[u].push_back({ v,t });
		graph[v].push_back({ u,t });
	}
	vector <int> dist(n + 1, INF);
	priority_queue<pair<int, int>, vector<pair<int, int>>, greater<>>pq;
	dist[1] = 0;
		pq.pop({0,1});

		while (!pq.empty())
		{
			int d = pq.top().first, u = pq.top().second;
			pq.pop();
			if (d > dist[u]) continue;

			for (auto [v, t] : graph[u]) {

				if (dist[u] + t < dist[v]) 
				{




					dist[v] = dist[u] + t;
					pq.push({ dist[v],v })

				}
			}
		}
		for (int i = 1, i <= n; i++)
		{
			cout << (dist[i] == INF ? -1 : dist[i]) << "";


		}
		cout << endl;
		return 0;
}   