#include <bits/stdc++.h>
#define INF 1e9+3
#define v second
#define w first
#define endl '\n'
using namespace std;
int N, M;
vector <pair<int, int>> G[100002];
bool used[100002];
int dist[100002];
priority_queue <int, vector<pair<int, int>>, greater<pair<int, int>> > pq;
void Dijkstra (int root)
{
    int curr;
    memset(used, 0, N+1);
    for (int i=1; i<=N; i++) dist[i]=INF;
    dist[1]=0;
    pq.push({0, 1});
    while (!pq.empty())
    {
        curr=pq.top().v;
       // cout << curr << " " << pq.top().w << endl;
        pq.pop();
        if (used[curr]) continue;
        used[curr]=1;
        for (auto q: G[curr])
        {
            if (!used[q.v] && dist[curr]+q.w < dist[q.v])
            {
                dist[q.v]=dist[curr]+q.w;
                pq.push({q.w, q.v});
            }
        }
    }
}
int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> N >> M;
    int u, l, r;
    for (int i=0; i<M; i++)
    {
        cin >> u >> l >> r;
        for (int j=l; j<=r; j++) G[u].push_back({j-l+1, j});
    }
    Dijkstra(1); cout << 0;
    for (int i=2; i<=N; i++)
    {
        if (dist[i]==INF) cout << " " << -1;
        else cout << " " << dist[i];
    }
    cout << endl;
    return 0;
}