#include <bits/stdc++.h>
#define INF 1e9+3
#define w first
#define v second
#define endl '\n'
using namespace std;
int N, M;
vector <pair<int, int>> G[100002];
bool used[100002];
int dist[100002];
priority_queue <int, vector<pair<int, int>>, greater<pair<int, int>> > pq;
void Dijkstra ()
{
    memset(used, 0, 100000);
    for (int i=1; i<=N; i++) dist[i]=10000002;
    dist[1]=0;
    pq.push({0, 1});
    while (!pq.empty())
    {
        int curr=pq.top().v;
        //cout << curr << " " << pq.top().w << endl;
        pq.pop();
        if (used[curr]) continue;
        used[curr]=1;
        for (auto q: G[curr])
        {
            if (!used[q.v] && dist[curr]+q.w < dist[q.v])
            {
                dist[q.v]=dist[curr]+q.w;
                pq.push({q.w, q.v});
            }
        }
    }
}
int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> N >> M;
    for (int i=0; i<M; i++)
    {
        int u, l, r;
        cin >> u >> l >> r;
        for (int j=l; j<=r; j++) {if (j==u) continue; else G[u].push_back({j-l+1, j});}
    }
    Dijkstra(); cout << 0;
    for (int i=2; i<=N; i++)
    {
        if (dist[i]==10000002) cout << " " << -1;
        else cout << " " << dist[i];
    }
    cout << endl;
    return 0;
}
/**
15 6
1 11 15
7 9 11
2 3 8
1 5 7
3 5 8
13 2 12

*/
