#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN = 100000 + 5;
vector <int> G[MAXN];
int n;

bool used[MAXN];

void dfs(int s)
{
    if (used[s]) return;
    used[s] = 1;
    for (auto &x: G[s])
    {
        dfs(x);
    }
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    cin >> n;
    for (int i = 2; i <= n; i++)
    {
        int a; cin >> a;
        G[a].push_back(i);
    }

    long long ans = 0;

    for (int l = 1; l <= n; l++)
    {
        for (int x = 1; x <= n; x++)
            used[x] = 0;

        for (int r = l; r <= n; r++)
        {
            dfs(r);

            long long cnt = 0;
            for (int x = 1; x <= n; x++)
                cnt += (used[x]);

            if (cnt == n - l + 1)
            {
                ans += cnt * (n - r + 1);
                break;
            }

            ans += cnt;
            //cerr << " ~ " << cnt << " / " << n-l+1 << endl;
        }
    }

    cout << ans << endl;

    return 0;
}
/**
6
5 5 1 1 4

6
1 1 2 2 3

*/
