#include<iostream>
#include<vector>
#include<queue>
using namespace std;

int g ;
int n , m ;
vector<pair<int,int>> a[100002] ;
int w[100002] ;
int ns ;

void CW( int pos )
{
    cout << endl ;
    for ( int i = 1 ; i <= n ; i++ )
        cout << w[i] << " " ;
    cout << endl ;
    cout << pos << endl ;
    cout << endl ;
}

priority_queue<pair<int,int>> q ;
int q1 , q2 ;
void OG( int pos , int pat )
{
    if ( pos == 1 && pat > 0 ) return ;
    if ( w[pos] > 0  && pat > w[pos] ) return ;

    w[pos] = pat ;

    ns = a[pos].size() ;
    for ( g = 0 ; g < ns ; g++ )
    {
        q1 = a[pos][g].first ;
        q2 = a[pos][g].second ;
        if ( w[q2] == 0 or pat + q1 < w[q2] ) q.push({-(pat+q1),q2}) ;
    }

    while ( !q.empty() )
    {
        q1 = -q.top().first ;
        q2 = q.top().second ;
        q.pop() ;
        if ( w[q2] == 0 or q1 < w[q2] ) OG( q2 , q1 ) ;
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);cout.tie(NULL);


    int u , l , r ;
    cin >> n >> m ;
    for ( int i = 1 ; i <= m ; i++ )
    {
        cin >> u >> l >> r ;
        for ( int j = l ; j <= r ; j++ )
            a[u].push_back({ (j-l+1) , j }) ;
    }

    OG( 1 , 0 ) ;

    cout << "0 " ;
    for ( int i = 2 ; i <= n ; i++ )
    {
        if ( w[i] == 0 ) cout << -1 ;
        else cout << w[i] ;
        if ( i < n ) cout << " " ;
    }
    cout << endl ;

    return 0 ;
}
/*
10 5
1 1 2
1 8 9
1 7 8
9 3 4
9 3 4
*/