#include<iostream>
#include<algorithm>
#include<cmath>
#include<vector>
#include<chrono>
#include<random>
#include<unordered_map>
#include<queue>
//#include<bits/stdc++.h>
using namespace std;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
static clock_t startT;
double timepassed()
{
    clock_t currT=clock();
    return (double)(currT-startT)/CLOCKS_PER_SEC;
}

const int MAX_N=1e5+5;
int n,m;
int dist[MAX_N];
int rangemx[MAX_N];
vector<pair<int,int>>g[MAX_N];
void bfs()
{
    for(int i=1;i<=n;i++)dist[i]=-1;
    dist[1]=0;
    queue<pair<int,pair<int,int>>>q;
    q.push({0,{1,0}});

    while(q.size())
    {
        int u=q.front().second.first;
        int range=q.front().second.second;
        int dis=q.front().first;
        q.pop();

        vector<pair<int,int>>s;
        if(range>u)
        {
            s.push_back({u+1,range});
        }
        for(auto ran:g[u])
        {
            s.push_back(ran);
        }

        for(auto&[x,r]:s)
        {
            if(dist[x]==-1 or r>rangemx[x])
            {
                if(dist[x]==-1)dist[x]=dis+1;
                rangemx[x]=r;
                q.push({dis+1,{x,r}});
            }
        }
    }

    for(int i=1;i<=n;i++)
    {
        cout<<dist[i]<<" ";
    }
    cout<<"\n";
}
int main ()
{
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n>>m;
    for(int i=1;i<=m;i++)
    {
        int u,l,r;
        cin>>u>>l>>r;

        g[u].push_back({l,r});
    }
    bfs();
    return 0;
}
