#include<iostream>
#include<algorithm>
#include<cmath>
#include<vector>
#include<chrono>
#include<random>
#include<set>
//#include<bits/stdc++.h>
using namespace std;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
static clock_t startT;
double timepassed()
{
    clock_t currT=clock();
    return (double)(currT-startT)/CLOCKS_PER_SEC;
}

const long long MAX_N=1e5+5;
set<long long>s;
vector<long long>g[MAX_N];
long long n;
long long ans;
long long cur;
long long len(long long x)
{
    return x*(x+1)/2;
}
void rem(long long x)
{
    auto it=s.upper_bound(x);
    long long nxt=(*it);
    it--;it--;
    long long pr=(*it);
    cur-=len(x-pr-1);
    cur-=len(nxt-x-1);
    cur+=len(nxt-pr-1);
    s.erase(x);
}
void add(long long x)
{
    auto it=s.upper_bound(x);
    long long nxt=(*it);
    it--;
    long long pr=(*it);
    cur-=len(nxt-pr-1);
    cur+=len(x-pr-1);
    cur+=len(nxt-x-1);
    s.insert(x);
}
void dfs(long long u,long long par)
{
    add(u);
    ans+=len(n)-cur;
    for(long long v:g[u])
    {
        if(v==par)continue;
        dfs(v,u);
    }
    rem(u);
}
signed main ()
{
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n;
    for(long long i=2;i<=n;i++)
    {
        long long x;
        cin>>x;
        g[i].push_back(x);
        g[x].push_back(i);
    }
    s.insert(0);
    s.insert(n+1);
    cur=len(n);
    dfs(1,0);
    cout<<ans<<"\n";
    return 0;
}
