#include <iostream>
#include <vector>
#include <queue>
using namespace std;

int n;
vector<int> v[100001];
int p[100001];
int sum = 0;
int used[100001];

void read(){
    cin >> n;
    for(int i = 0; i < n-1; i++){
        cin >> p[i];
        v[p[i]].push_back(i+2);
    }
}

void bfs(int beg){
    queue<int> q;
    q.push(beg);
    sum ++;

    while(!q.empty()){
        int w = q.front();
        q.pop();
        for(int i = 0; i < v[w].size(); i++){
            q.push(v[w][i]);
            sum ++;
        }
    }
}

int main(){
    read();
    for(int i = 1; i < n; i++){
        for(int j = i+1; j <=n; j++){
            sum ++;
            bfs(i);
            bfs(j);
        }
    }
    cout << sum;
    return 0;
}
