#include <iostream>
#include <vector>
#include <algorithm>

int main() {
    int n, k;
    std::cin >> n >> k;

    std::vector<int> multiset;

    for (int i = 0; i < n; ++i) {
        int num;
        std::cin >> num;
        multiset.push_back(num);

        std::sort(multiset.begin(), multiset.end());

        long long beauty = 0;

        for (size_t j = 0; j < multiset.size(); ++j) {
            if ((j + 1) % k == 1) {
                beauty += multiset[j];
            }
            if (j >= static_cast<size_t>(k * ((multiset.size() - j - 1) / k))) break;
        }

        std::cout << beauty << "\n";
    }

    return 0;
}

