#include<iostream>
#include<vector>
#include<queue>
#include<climits>
using namespace std;
int n,re;
vector<pair<int,int>> m[100000];
long dist[100000];
void djikstra()
{
    fill_n(dist,n,LONG_MAX);
    dist[0]=0;
    priority_queue<pair<int,int>> q;
    q.push({0,0});
    while(!q.empty())
    {
        auto cur=q.top();q.pop();
        if(dist[cur.second]>=-cur.first)
        {
            for(auto v:m[cur.second])
            {
                if(dist[v.first]>dist[cur.second]+v.second)
                {
                    dist[v.first]=dist[cur.second]+v.second;
                    q.push({-dist[v.first],v.first});
                }
            }
        }
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n>>re;
    int u,l,r;
    for(int i=0;i<re;i++)
    {
        cin>>u>>l>>r;
        for(int L=l;L<=r;L++)
        {
            if(L!=u) m[u-1].push_back({L-1,L-l+1});
        }
    }
    djikstra();
    for(int i=0;i<n;i++)
    {
        if(dist[i]==LONG_MAX) cout<<-1<<" ";
        else
        cout<<dist[i]<<" ";
    }
    cout<<endl;
}

