#include<iostream>
#include<vector>
#include<queue>
#define MAXN 4010
#define INF 9999999
using namespace std;
vector<int> edges[MAXN];
int dist[MAXN];
int cost[MAXN][MAXN];
void bfs(int n)
{
    for(int i=1;i<=n;i++)dist[i]=INF;
    priority_queue<pair<int,int>> q;
    q.push({0,1});
    while(!q.empty())
    {
        int curr=q.top().second;
        int val=-q.top().first;
        q.pop();
        if(val>dist[curr])continue;
        dist[curr]=val;
        for(int i=0;i<edges[curr].size();i++)
        {
            int now=edges[curr][i],w=cost[curr][now];
            if(val+w<dist[now])
            {
                dist[now]=val+w;
                q.push({-dist[now],now});
            }
        }
    }
}
int main()
{
    int n,m;
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin>>n>>m;
    for(int q=0;q<m;q++)
    {
        int u,l,r;
        cin>>u>>l>>r;
        for(int i=l;i<=r;i++)
        {
            if(cost[u][i]==0)
            {
                cost[u][i]=i-l+1;
                edges[u].push_back(i);
            }
            else cost[u][i]=min(cost[u][i],i-l+1);
        }
    }
    bfs(n);
    for(int i=1;i<=n;i++)
    {
        if(dist[i]==INF)cout<<"-1 ";
        else cout<<dist[i]<<" ";
    }
    cout<<"\n";
}