#include<bits/stdc++.h>
#define maxn 100010
#define ll long long
#define f first
#define s second
using namespace std;
ll n,k;
ll a[maxn];
int fen[maxn];
void updatef(int idx,int val)
{
    for(;idx<maxn;idx+=idx&(-idx))
    {
        fen[idx]+=val;
    }
}
int queryf(int idx)
{
    int ans=0;
    for(;idx>0;idx-=idx&(-idx))
    {
        ans+=fen[idx];
    }
    return ans;
}
pair<int,int> tree[4*maxn];
bool lazy[4*maxn];
void pushLazy(int node,int l,int r)
{
    if(lazy[node])
    {
        swap(tree[node].f,tree[node].s);
        if(l!=r)
        {
            lazy[node*2]^=1;
            lazy[node*2+1]^=1;
        }
    }
    lazy[node]=0;
}
void update(int ul,int ur,int node=1,int l=1,int r=n)
{
    pushLazy(node,l,r);
    if(r<ul || ur<l) return;

    if(ul<=l && r<=ur)
    {
        swap(tree[node].f,tree[node].s);
        if(l!=r)
        {
            lazy[node*2]^=1;
            lazy[node*2+1]^=1;
        }
        return;
    }
    int mid=(l+r)/2;
    int left=node*2,right=left+1;
    update(ul,ur,left,l,mid);
    update(ul,ur,right,mid+1,r);
    tree[node]={tree[left].f+tree[right].f,tree[left].s+tree[right].s};
}
void update2(int idx,int val,bool type,int node=1,int l=1,int r=n)
{
    pushLazy(node,l,r);
    if(idx<l || r<idx) return;

    if(l==r)
    {
        if(!type) tree[node].s+=val;
        else tree[node].f+=val;
        return;
    }
    int mid=(l+r)/2;
    int left=node*2,right=left+1;
    update2(idx,val,type,left,l,mid);
    update2(idx,val,type,right,mid+1,r);
    tree[node]={tree[left].f+tree[right].f,tree[left].s+tree[right].s};
}
vector<pair<int,int>> nums;
int alloc[maxn];
int query(int ql,int qr,int node=1,int l=1,int r=n)
{
    pushLazy(node,l,r);
    if(r<ql || qr<l) return 0;

    if(ql<=l && r<=qr) return tree[node].s;
    int mid=(l+r)/2;
    int left=node*2,right=left+1;
    int ans=0;
    ans+=query(ql,qr,left,l,mid);
    ans+=query(ql,qr,right,mid+1,r);
    return ans;
}
void printingg(int node=1,int l=1,int r=n)
{
    pushLazy(node,l,r);
    if(l==r)
    {
        printf("{%d %d} ",tree[node].f,tree[node].s);
        return;
    }
    int mid=(l+r)/2;
    int left=node*2,right=left+1;
    printingg(left,l,mid);
    printingg(right,mid+1,r);
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin>>n>>k;
    for(ll i=0;i<n;i++)
    {
        cin>>a[i];
        nums.push_back({a[i],i});
    }
    sort(nums.begin(),nums.end());
    int cntr=1;
    for(auto e:nums)
    {
        alloc[e.s]=cntr++;
    }
    for(int i=0;i<n;i++)
    {
        int pos=alloc[i];
        int newpos=queryf(pos);
        //printf("for %d new pos %d pos %d\n",a[i],newpos,pos);
        //printf("done %d 1\n",i);
        updatef(pos,1);
       // printf("done %d 2\n",i);
        if(newpos%2==0)
        {
            update2(pos,a[i],0);
        }
        else
        {
            update2(pos,a[i],1);
        }
        //printf("done %d 3\n",i);
        if(pos!=n) update(pos+1,n);
        //printf("done %d 4\n",i);
        cout<<query(1,n)<<"\n";
        //printingg();
        //printf("\n");
    }
    //printing();
}
/*
6 2
5 6 1 1 4 7
*/
