#include<bits/stdc++.h>
#define maxn 100010
#define ll long long
#define f first
#define s second
using namespace std;
ll n,k;
ll a[maxn];
ll fen[maxn];
void updatef(ll idx,ll val)
{
    for(;idx<maxn;idx+=idx&(-idx))
    {
        fen[idx]+=val;
    }
}
ll queryf(ll idx)
{
    ll ans=0;
    for(;idx>0;idx-=idx&(-idx))
    {
        ans+=fen[idx];
    }
    return ans;
}
pair<ll,ll> tree[4*maxn];
bool lazy[4*maxn];
void pushLazy(ll node,ll l,ll r)
{
    if(lazy[node])
    {
        swap(tree[node].f,tree[node].s);
        if(l!=r)
        {
            lazy[node*2]^=1;
            lazy[node*2+1]^=1;
        }
    }
    lazy[node]=0;
}
void update(ll ul,ll ur,ll node=1,ll l=1,ll r=n)
{
    pushLazy(node,l,r);
    if(r<ul || ur<l) return;

    if(ul<=l && r<=ur)
    {
        swap(tree[node].f,tree[node].s);
        if(l!=r)
        {
            lazy[node*2]^=1;
            lazy[node*2+1]^=1;
        }
        return;
    }
    ll mid=(l+r)/2;
    ll left=node*2,right=left+1;
    update(ul,ur,left,l,mid);
    update(ul,ur,right,mid+1,r);
    tree[node]={tree[left].f+tree[right].f,tree[left].s+tree[right].s};
}
void update2(ll idx,ll val,bool type,ll node=1,ll l=1,ll r=n)
{
    pushLazy(node,l,r);
    if(idx<l || r<idx) return;

    if(l==r)
    {
        if(!type) tree[node].s+=val;
        else tree[node].f+=val;
        return;
    }
    ll mid=(l+r)/2;
    ll left=node*2,right=left+1;
    update2(idx,val,type,left,l,mid);
    update2(idx,val,type,right,mid+1,r);
    tree[node]={tree[left].f+tree[right].f,tree[left].s+tree[right].s};
}
vector<pair<ll,ll>> nums;
ll alloc[maxn];
ll query(ll ql,ll qr,ll node=1,ll l=1,ll r=n)
{
    pushLazy(node,l,r);
    if(r<ql || qr<l) return 0;

    if(ql<=l && r<=qr) return tree[node].s;
    ll mid=(l+r)/2;
    ll left=node*2,right=left+1;
    ll ans=0;
    ans+=query(ql,qr,left,l,mid);
    ans+=query(ql,qr,right,mid+1,r);
    return ans;
}
void prllingg(ll node=1,ll l=1,ll r=n)
{
    pushLazy(node,l,r);
    if(l==r)
    {
        printf("{%d %d} ",tree[node].f,tree[node].s);
        return;
    }
    ll mid=(l+r)/2;
    ll left=node*2,right=left+1;
    prllingg(left,l,mid);
    prllingg(right,mid+1,r);
}
multiset<ll> st;
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin>>n>>k;
    for(ll i=0;i<n;i++)
    {
        cin>>a[i];
        nums.push_back({a[i],i});
    }
    if(k>=sqrt(n)+1)
    {
        for(ll i=0;i<n;i++)
        {
            st.insert(a[i]);
            ll cntr=0;
            ll ans=0;
            for(auto e:st)
            {
                if(cntr%k==0)ans+=e;
                cntr++;
            }
            cout<<ans<<"\n";
        }
        return 0;
    }
    sort(nums.begin(),nums.end());
    ll cntr=1;
    for(auto e:nums)
    {
        alloc[e.s]=cntr++;
    }
    for(ll i=0;i<n;i++)
    {
        ll pos=alloc[i];
        ll newpos=queryf(pos);
        updatef(pos,1);
        if(newpos%2==0)
        {
            update2(pos,a[i],0);
        }
        else
        {
            update2(pos,a[i],1);
        }
        if(pos!=n) update(pos+1,n);
        cout<<query(1,n)<<"\n";
    }
}

