#include <bits/stdc++.h>
using namespace std;

long long const maxd=2e9;
int n,m,dist[100003];
vector<pair<int,int>> rebra;
map<pair<int,int>,int> mp;
vector<pair<int,int>> d[100003];

void dijkstra(){
    priority_queue<pair<int,int>> pq;
    pq.push({0,1});
    for(int i=2;i<=n;i++) dist[i]=maxd;
    while(!pq.empty()){
        int curr=pq.top().second;
        int p=-pq.top().first;
        pq.pop();
        if(dist[curr]<p) continue;
        for(auto i: d[curr]){
            if(dist[i.first]>p+i.second){
                dist[i.first]=p+i.second;
                pq.push({-dist[i.first],i.first});
            }
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin>> n >> m;
    for(int i=0;i<m;i++){
        int u,l,r;
        cin>> u >> l >> r;
        for(int j=l;j<=r;j++){
            if(u==j) continue;
            int x=u, y=j, z=j-l+1;
            if(x>y) swap(x,y);
            if(mp[{x,y}]==0){
                mp[{x,y}]=z;
                rebra.push_back({x,y});
            }else if(mp[{x,y}]>z){
                mp[{x,y}]=z;
            }
        }
    }
    for(auto i: rebra){
        d[i.first].push_back({i.second,mp[{i.first,i.second}]});
        d[i.second].push_back({i.first,mp[{i.first,i.second}]});
        //cout<< i.first << " " << i.second << " :: " << mp[{i.first,i.second}] << endl;
    }
    dijkstra();
    for(int i=1;i<=n;i++){
        if(dist[i]==maxd) cout<< -1 << " ";
        else cout<< dist[i] << " ";
    }





    return 0;
}
