#include <bits/stdc++.h>
using namespace std;

long long const maxd=2e9;
long long n,m,dist[100003];
vector<pair<long long,long long>> rebra;
map<pair<long long,long long>,long long> mp;
vector<pair<long long,long long>> d[100003];

void dijkstra(){
    priority_queue<pair<long long,long long>> pq;
    pq.push({0,1});
    for(long long i=2;i<=n;i++) dist[i]=maxd;
    while(!pq.empty()){
        long long curr=pq.top().second;
        long long p=-pq.top().first;
        pq.pop();
        if(dist[curr]<p) continue;
        for(auto i: d[curr]){
            if(dist[i.first]>p+i.second){
                dist[i.first]=p+i.second;
                pq.push({-dist[i.first],i.first});
            }
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin>> n >> m;
    for(long long i=0;i<m;i++){
        long long u,l,r;
        cin>> u >> l >> r;
        /*for(long long j=l;j<=r;j++){
            if(u==j) continue;
            long long x=u, y=j, z=j-l+1;
            if(mp[{x,y}]==0){
                mp[{x,y}]=z;
                rebra.push_back({x,y});
            }else if(mp[{x,y}]>z){
                mp[{x,y}]=z;
            }
        }*/
    }
    for(long long i=1;i<n;i++){
        for(long long j=i+1;j<=n;j++){
            d[i].push_back({j,1});
        }
    }
    //for(auto i: rebra){
    //    d[i.first].push_back({i.second,mp[{i.first,i.second}]});
        //cout<< i.first << " " << i.second << " :: " << mp[{i.first,i.second}] << endl;
    //}
    dijkstra();
    for(long long i=1;i<=n;i++){
        if(dist[i]==maxd) cout<< -1 << " ";
        else cout<< dist[i] << " ";
    }





    return 0;
}
/*
10 7
1 1 2
1 8 9
1 7 8
9 3 4
9 3 4
3 2 9
2 7 7



*/
