//it is your desire to work hard

#include<bits/stdc++.h>
#define pb push_back
using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef complex<double> C;

const int maxn=1e5+3;
const int mod=1e9+7;

int n, m;

vector<pii> edges[maxn];

struct Entry{
    int to, dist;
};

bool operator < (const Entry& l, const Entry& r){
    return l.dist > r.dist;
}

ll dist[maxn];
vector<int> curr_edges;

ll get_distances(int x, int y){
    curr_edges.clear();

    /*for(int i=0; i<edges[x].size(); i++){
        if(edges[x][i].first<=y and edges[x][i].second>=y){
            curr_edges.pb(y - edges[x][i].first + 1);
        }

        if(edges[x][i].first>y) break;
    }*/

    int l=0, r=edges[x].size()-1;

    if(l==r){
        if(edges[x][l].first<=y and edges[x][l].second>=y){
            //cerr<<x<<" ima 1 edge, ama sh stane za "<<y<<" s dist "<<y-edges[x][l].first+1<<endl;
            return y-edges[x][l].first+1;
        }else{
            //cerr<<x<<" ima 1 edge, ama nqq stane za "<<y<<endl;
            return -1;
        }
    }

    while(l!=r-1){
        int mid=(l+r)/2;

        if(edges[x][mid].first>y){
            r=mid;
        }else{
            l=mid;
        }
    }
    //cerr<<"searching from "<<x<<" to "<<y<<" and it seems best to do the edge "<<edges[x][l].first<<" "<<edges[x][l].second<<endl;
    //cerr<<"cand is for "<<edges[x][l+1].first<<" "<<edges[x][l+1].second<<endl;
    ll cand=-1;
    if(edges[x][l+1].first<=y and edges[x][l+1].second>=y){
        cand=y-edges[x][r].first+1;
    }
    //cerr<<"cand="<<cand<<endl;

    if(edges[x][l].first>y or edges[x][l].second<y){
        if(cand==-1) return -1;
        else return cand;
    }else{
        if(cand!=-1) return min(ll(y - edges[x][l].first + 1), cand);
        else return (y - edges[x][l].first + 1);
    }
}

int main(){

ios_base::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);

cin>>n>>m;

for(int i=0; i<m; i++){
    int a, l, r;
    cin>>a>>l>>r;

    edges[a].pb({l, r});
}

for(int i=1; i<=n; i++) sort(edges[i].begin(), edges[i].end());

for(int i=0; i<=n; i++) dist[i]=-1;

// start Dijkstra
dist[1]=0;
priority_queue<Entry> q;
q.push({1, 0});

while(!q.empty()){
    Entry curr_entry = q.top();
    q.pop();
    int curr=curr_entry.to;
    int curr_dist=curr_entry.dist;

    ////cerr<<"at "<<curr<<endl;

    if(dist[curr]>curr_dist) continue;

    for(int i=1; i<=n; i++){
        if(i==curr or edges[curr].size()==0) continue;

        ll d=get_distances(curr, i);

        ////cerr<<"got the dist from "<<curr<<" to "<<i<<" to be "<<d<<endl;

        if(d==-1) continue;


        if(dist[i]==-1 or dist[i]>curr_dist + d){
            dist[i]=curr_dist+d;
            q.push({i, dist[i]});
            ////cerr<<"pushed "<<i<<" with dist "<<dist[i]<<endl;
        }
    }
}

for(int i=1; i<=n; i++){
    cout<<dist[i]<<" ";
}

return 0;
}
