#include<iostream>
#include<queue>
using namespace std;
const int MAXN = 2*1e4+5;
int vryzka[MAXN][MAXN];
vector<pair<int,int>> susedi[MAXN];
priority_queue<pair<long long,int>> pq;
long long ans[MAXN];
void dijkstra(int vr){
    pq.push({0,vr});
    long long dist;
    while(!pq.empty()){
        vr=pq.top().second;
        dist=-pq.top().first;
        pq.pop();
        for(auto to:susedi[vr]){
            if(dist+to.second<ans[to.first]){
                ans[to.first]=dist+to.second;
                pq.push({-ans[to.first],to.first});
            }
        }
    }
}
int main () {
    int n,m;
    cin>>n>>m;
    int u,l,r;
    for(int q=0;q<m;q++){
        cin>>u>>l>>r;
        u--;
        l--;
        r--;
        for(int v=l;v<=r;v++){
            if(vryzka[u][v]==0 or vryzka[u][v]>v-l+1){
                vryzka[u][v]=v-l+1;
            }
        }
    }
    for(int i=0;i<n;i++){
        ans[i]=1e11;
        for(int j=0;j<n;j++){
            //if(vryzka[i][j]!=0) cout<<"razst ot "<<i<<" do "<<j<<" e "<<vryzka[i][j]<<"\n";
            if(vryzka[i][j]>0){
                susedi[i].push_back({j,vryzka[i][j]});
            }
        }
    }
    ans[0]=0;
    dijkstra(0);
    for(int i=0;i<n;i++){
        if(ans[i]<=1e10) cout<<ans[i]<<" ";
        else cout<<-1<<" ";
    }
    cout<<"\n";
    return 0;
}
