#include<iostream>
#include<algorithm>
#include<queue>
#include<vector>
using namespace std;
const int MAXN = 2*1e5+5;
vector<pair<int,int>> susedi[MAXN];
priority_queue<pair<long long,int>> pq;
long long ans[MAXN];
struct compressed{
    int u,l,r;
};
compressed inp[MAXN];
bool el(compressed a1,compressed a2){
    if(a1.u==a2.u){
        if(a1.l==a2.l){
            return a1.r<a2.r;
        }else{
            return a1.l<a2.l;
        }
    }else{
        return a1.u<a2.u;
    }
}
void dijkstra(int vr){
    pq.push({0,vr});
    long long dist;
    while(!pq.empty()){
        vr=pq.top().second;
        dist=-pq.top().first;
        pq.pop();
        for(auto to:susedi[vr]){
            if(dist+to.second<ans[to.first]){
                ans[to.first]=dist+to.second;
                pq.push({-ans[to.first],to.first});
            }
        }
    }
}
int main () {
    int n,m;
    cin>>n>>m;
    for(int i=0;i<m;i++){
        cin>>inp[i].u>>inp[i].l>>inp[i].r;
        inp[i].u--;
        inp[i].l--;
        inp[i].r--;
    }
    sort(inp,inp+m,el);
    int currind;
    for(int i=0;i<n;i++){
        currind = inp[i].l;
        if(i<n-1 and inp[i].u==inp[i+1].u and inp[i].r>=inp[i+1].l){
            for(;currind<inp[i+1].l;currind++){
                susedi[inp[i].u].push_back({currind,currind-inp[i].l+1});
            }
        }else{
            for(;currind<=inp[i].r;currind++){
                susedi[inp[i].u].push_back({currind,currind-inp[i].l+1});
            }
        }
    }
    for(int i=1;i<n;i++){
        ans[i]=1e11;
    }
    dijkstra(0);
    for(int i=0;i<n;i++){
        if(ans[i]<=1e10) cout<<ans[i]<<" ";
        else cout<<-1<<" ";
    }
    cout<<"\n";
    return 0;
}

