#include<iostream>
#include<unordered_map>
#include<algorithm>
#define endl '\n'
using namespace std;
long long n,k,fen[100005],a[100005],a2[100005];
bool lazy[500005];
long long tree[500005][3];
void update(long long t)
{
    for(long long i=t;i<=n;i+= (i & -i))
    {
        fen[i]++;
    }
}
void updateint(int node,int l,int r,int le,int ri)
{
    if(l>=le && r<=ri)
    {
        lazy[node]=!lazy[node];
    }
    if(lazy[node]==1)
    {
        swap(tree[node][0],tree[node][1]);
        if(l!=r)
        {
            lazy[2*node]=!lazy[2*node];
            lazy[2*node+1]=!lazy[2*node+1];
        }
        lazy[node]=0;
    }
    if(l>=le && r<=ri) return;
    if(l>ri || r<le) return;

    int mid=(l+r)/2;
    updateint(2*node,l,mid,le,ri);
    updateint(2*node+1,mid+1,r,le,ri);

    tree[node][0]=tree[2*node][0]+tree[2*node+1][0];
    tree[node][1]=tree[2*node][1]+tree[2*node+1][1];
}
void updatenum(int node,int l,int r,long long num,long long val,bool isch)
{
    if(lazy[node]==1)
    {
        swap(tree[node][0],tree[node][1]);
        if(l!=r)
        {
            lazy[2*node]=!lazy[2*node];
            lazy[2*node+1]=!lazy[2*node+1];
        }
        lazy[node]=0;
    }
    if(l>num || r<num) return;

    if(l==r)
    {
        tree[node][isch]+=val;
        return;
    }
     int mid=(l+r)/2;
     updatenum(2*node,l,mid,num,val,isch);
     updatenum(2*node+1,mid+1,r,num,val,isch);

     tree[node][0]=tree[2*node][0]+tree[2*node+1][0];
     tree[node][1]=tree[2*node][1]+tree[2*node+1][1];
}
long long qsum()
{
    if(lazy[1]==1)
    {
        swap(tree[1][0],tree[1][1]);
        lazy[2]=!lazy[2];
        lazy[3]=!lazy[3];
        lazy[1]=0;
    }
    tree[1][0]=tree[2][0]+tree[3][0];
    tree[1][1]=tree[2][1]+tree[3][1];
    return tree[1][0];
}
int query(long long n)
{
    int pos=0;
    for(long long i=n;i>=1;i-= (i & -i))
    {
        pos+=fen[i];
    }
    return pos;
}
int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>k;
    unordered_map<long long,int> mp;
    int ma=0;

    long long p,s;
    bool isch;

    for(int i=0;i<n;i++)
    {
        cin>>a[i];
        a2[i]=a[i];
    }
    sort(a2,a2+n);

    for(int i=0;i<n;i++)
    {
       if(!mp.count(a2[i]))
        {
            ma++;
            mp[a2[i]]=ma;
        }
    }
    for(int i=0;i<n;i++)
    {
        int p=query(mp[a[i]]);

        p++;
        if(p%k==1) isch=0;
        else isch=1;

        //cout<<p<<" "<<isch<<endl;

        updateint(1,1,n,mp[a[i]]+1,n);
        updatenum(1,1,n,mp[a[i]],a[i],isch);


        cout<<qsum()<<endl;
        update(mp[a[i]]);
    }


}
/*
6 2
5 6 1 1 4 7
*/
