#include <iostream>
#include <set>
#include <vector>
using namespace std;
const int MAXN = 1e5 + 1;
set<int> ancestors;
long long mark[MAXN];
int parent[MAXN];
vector<int> kids[MAXN];

void dfs(int curr, const int n) {
    set<int>::iterator it = ancestors.lower_bound(curr);

//    cout << curr << ": ";
    for (auto tok : ancestors) {
//        cout << tok << ' ';
    }
//    cout << '\n';

    long long l, r;
    if (it == ancestors.end()) {
        r = n;
    } else {
        r = *it - 1;
    }
    if (ancestors.empty()) {
        l = 1;
    } else {
        it--;
        l = *it + 1;
    }

//    cout << l << ' ' << r << '\n';

    mark[curr] = mark[parent[curr]] + (curr - l + 1) * (r - curr + 1);
//    cout << mark[curr] << '\n';

    ancestors.insert(curr);
    for (auto child : kids[curr]) {
        dfs(child, n);
    }
    ancestors.erase(curr);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    for (int i = 2; i <= n; i++) {
        cin >> parent[i];
        kids[parent[i]].push_back(i);
    }

    parent[1] = 0;
    mark[0] = 0;
    dfs(1, n);

    long long ans = 0;
    for (int i = 1; i <= n; i++) {
        ans += mark[i];
    }
    cout << ans;
    return 0;
}
