#include <bits/stdc++.h>
using namespace std;
int n,m;
const int maxn=4e3+1;
vector<pair<int, int>>edges[maxn];
int u, l, r;
int dist[maxn];
int inf=INT_MAX-1;
bool used[maxn];
void read()
{
    cin>>n>>m;
    for(int i=0;i<m;i++)
    {
        cin>>u>>l>>r;
        for(int j=l;j<=r;j++)
        {
            if(u!=j)
            {
                edges[u].push_back({j, j-l+1});
            }
        }
    }
}
void dfs(int st)
{
    used[st]=1;
    for(auto to: edges[st])
    {
        if(!used[to.first])
        {
            dfs(to.first);
        }
    }
}
void prec()
{
    for(int i=2;i<=n;i++)
    {
        dist[i]=inf;
    }
}
void solve()
{
    dist[1]=0;
    for(int i=1;i<=n;i++)
    {
        for(auto j: edges[i])
        {
            if(dist[j.first]>dist[i]+j.second)
            {
                dist[j.first]=dist[i]+j.second;
            }
        }
    }
    cout<<dist[1]<<" ";
    dfs(1);
    for(int i=2;i<n;i++)
    {
        if(used[i])
        {
            cout<<dist[i]<<" ";
        }
        else
        {
            cout<<"-1"<<" ";
        }
    }
    if(used[n])
    {
        cout<<dist[n]<<endl;
    }
    else
    {
        cout<<"-1"<<endl;
    }
}
int main()
{
    read();
    prec();
    solve();
    return 0;
}
