#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
const int MAXN = 4e3+10;
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

int n, m;
int a[MAXN];
int act[MAXN/**u*/][MAXN /**l*/];
void read()
{
    cin >> n >> m;
    memset(act, -1, sizeof(act));
    for (int i = 1; i <= m; ++ i)
    {
        int u, l, r;
        cin >> u >> l >> r;
        act[u][l] = max(act[u][l], r);
    }
}
vector < pair < int, int > > g[MAXN];
void make_graph()
{
    for (int i = 1; i <= n; ++ i)
    {
        vector < pair < int, int > > f;
        for (int j = 1; j <= n; ++ j)
        {
            while(f.size() && f.back().second < j)f.pop_back();
            if(act[i][j] != -1)
            {
                f.push_back(make_pair(j, act[i][j]));
            }
            if(f.size() == 0)continue;
            int wl = f.back().first;
            g[i].push_back(make_pair(j, j - wl + 1));
        }

       /// cout << "printing edges for " << i << endl;
      //  for (auto &[to, cost]: g[i])
       //     cout << to << " " << cost << endl;
    }
}

int used[MAXN];
long long dist[MAXN];
void dijkstra()
{
    for (int i = 1; i <= n; ++ i)
    {
        dist[i] = 1e17;
        used[i] = 0;
    }
    priority_queue < pair < long long, int > > q;
    q.push(make_pair(0, 1));
    dist[1] = 0;
    while(!q.empty())
    {
        int w = q.top().second;
        q.pop();
        if(used[w])continue;
        used[w] = 1;
        for (auto &[to, cost]: g[w])
        {
            if(!used[to] && dist[to] > dist[w] + cost)
            {
                dist[to] = dist[w] + cost;
                q.push(make_pair(-dist[to], to));
            }
        }
    }
    for (int i = 1; i <= n; ++ i)
    {
        if(dist[i] == 1LL * 1e17)cout << -1 << " ";
        else cout << dist[i] << " ";
    }
    cout << endl;
}
int main()
{
    speed();
    read();
    make_graph();
    dijkstra();
    return 0;
}
