#include<bits/stdc++.h>


using namespace std;

const int maxn = 10001;
struct edge
{
    int v; long long w;
    bool operator <(const edge& e)const
    {
        return w>e.w;
    }
};

struct seg_el
{
    bool type; // 0 - open, 1 - close
    int ind, l;
};
bool cmp(seg_el s1, seg_el s2)
{
    if(s1.ind<s2.ind)
    {
        return 1;
    }
    if(s1.ind>s2.ind)
    {
        return 0;
    }
    if(s1.ind==s2.ind)
    {
        if(s1.type==s2.type)
        {
            if(s1.l<s2.l)
            {
                return  1;
            }
            else return 0;
        }
        if(s1.type == 1 && s2.type == 0)
        {
            return 0;
        }
        return 1;
    }
    return 1;
}
int n, m;
unsigned int mat[maxn][maxn];
vector<seg_el>segs[maxn];
vector<edge>v[maxn];
void read_init()
{
    //cout<<"S"<<endl;
    cin>>n>>m;
    //cout<<n<<" "<<m<<endl;
    int u, l, r;
    for(int i = 0; i<m;i++)
    {
        cin>>u>>l>>r;
        segs[u].push_back({0, l , l});
        segs[u].push_back({1, r , l});
    }
    //cout<<"READ"<<endl;
    for(int i=1;i<=n;i++)
    {
        sort(segs[i].begin(), segs[i].end(), cmp);
    }
    //cout<<"SORTED"<<endl;
    for(int i=1;i<=n;i++)
    {
        multiset<int>st;
        for(int j = 0;j<segs[i].size();j++)
        {
            if(segs[i][j].type==0)
            {
                //cout<<"open"<<endl;
                st.insert(segs[i][j].l);
                int a = segs[i][j].ind;
                int b = segs[i][j+1].ind + (int)segs[i][j+1].type;
                for(int k = a; k<b;k++)
                {
                    mat[i][k] = k - a + 1;
                }
            }
            if(segs[i][j].type==1)
            {
                //cout<<"close"<<endl;
                bool t = segs[i][j-1].type;
                //cout<<t<<endl;
                if(t==1)
                {
                    int a = segs[i][j-1].ind+1;
                    int l = *(st.rbegin());
                    int b = segs[i][j].ind;
                    for(int k = a; k<=b;k++)
                    {
                        mat[i][k] = k - l + 1;
                    }
                }
                st.erase(st.find(segs[i][j].l));
            }
            //cout<<j<<endl;
        }
        //cout<<i<<endl;
    }
    //cout<<"WTH-ed"<<endl;
    for(int i = 1;i<=n;i++)
    {
        for(int j = 1;j<=n;j++)
        {
            if(mat[i][j]>0)v[i].push_back({j, mat[i][j]});
            //cout<<mat[i][j]<<" ";
        }
        //cout<<endl;
    }
}


unsigned long long d[100001];
void init()
{
    for(int i = 2;i<=n;i++)
    {
        d[i]=-1;
    }
}
bool used[maxn];
void Dijkstra()
{
    priority_queue<edge>q;
    q.push({1, 0});
    while(!q.empty())
    {
        edge e = q.top();q.pop();
        if(!used[e.v])
        {
            used[e.v] = 1;
            if(e.w<=d[e.v])
            {
                for(int i = 0; i<v[e.v].size();i++)
                {
                    edge nb = v[e.v][i];
                    //_nb.v = nb->first;
                    nb.w = e.w + nb.w;
                    if(nb.w<d[nb.v])
                    {
                        d[nb.v] = nb.w;
                        q.push(nb);
                    }
                }
            }
        }
    }
}

void print()
{
    for(int i = 1; i<=n; i++)
    {
        if(d[i]==(unsigned long long)-1)
        {
            cout<<-1<<" ";
        }
        else cout<<d[i]<<" ";
    }
    cout<<endl;
}


int main()
{
    //cin>>n>>m;
    read_init();
    init();
    Dijkstra();
    print();
    return 0;
}
