#include<bits/stdc++.h>
using namespace std;

const int maxn = 22222;
int n, m, a[maxn][maxn];
bool used[maxn];
long long d[maxn];
struct edge
{
    int ver;
    long long p;
    bool operator<(const edge&e)const
    {
        return (p > e.p);
    }
};
vector <edge> v[maxn];

void dijkstra(int ver)
{
    for (int i=0; i<=n; ++i)
        d[i] = LLONG_MAX;
    //memset(d, -1, sizeof(d));
    d[ver] = (long long)(0);
    priority_queue <edge> q;
    edge e{ver, (long long)(0)}, nb;
    q.push(e);
    int i, len;

    while (!q.empty())
    {
        e = q.top(); q.pop();
        if (!used[e.ver])
        {
            used[e.ver] = true;
            len = (int)(v[e.ver].size());
            for (i=0; i<len; ++i)
            {
                nb = v[e.ver][i];
                if (e.p + nb.p < d[nb.ver])
                {
                    nb.p += e.p;
                    d[nb.ver] = nb.p;
                    q.push(nb);
                }
            }
        }
    }
}

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> n >> m ;
    int i, u, l, r, j;
    for (i=1; i<=m; ++i)
    {
        cin >> u >> l >> r ;
        for (j=l; j<=r; ++j)
        {
            if (a[u][j] == 0 || (j-l+1) < a[u][j])
                a[u][j] = (long long)(j-l+1);
        }
    }

    for (i=1; i<=n; ++i)
    {
        for (j=1; j<=n; ++j)
        {
            if (i == j || a[i][j] == 0) continue;
            v[i].push_back({j, a[i][j]});
        }
    }

    dijkstra(1);
    for (i=1; i<=n; ++i)
    {
        if (d[i] == LLONG_MAX)
            cout << "-1 ";
        else
            cout << d[i] << " " ;
    }
    cout << '\n' ;
}

int main()
{
    read();
    return 0;
}