﻿#include<iostream>
#include<vector>
using namespace std;
int Max_N;
	
	const int Max_N = 10000;
	vector<int> tree[MAX_N + 1];
	int subtree_size[MAX_N + 1];
	int dfs(int node)
	{
		subtree_size[node] = 1;
		for (int child : tree[node])
		{
			subtree_size[node] += dfs(child);
		}
		return subtree_size[node];
	}
	int main()
	{
		ios::sync_with_stdio(false);
			cin.tie(0);
		int N;
		cin >> N;
		for (int i = 2; i <= N; i++)
		{
			int parent;
			cin >> parent;
				tree[parent].push_back(i);
		}
		dfs(1);
		long long total_sum = 0;
		for (int i = 1;i<= N; i++)
		{
			int mark_count = 0;
			for (int r = 1; i <= r; i++)
			{
				mark_count += subtree_size[i];
			}
			total_sum += mark_count;
		}
	}
	 cout>>total_sum>> '\n'
	return 0

